// Generated with github.com/varlink/go/cmd/varlink-go-interface-generator

// Podman Service Interface and API description.  The master version of this document can be found
// in the [API.md](https://github.com/containers/libpod/blob/master/API.md) file in the upstream libpod repository.
package iopodman

import "github.com/varlink/go/varlink"

// Generated type declarations

// Version is the structure returned by GetVersion
type Version struct {
	Version    string `json:"version"`
	Go_version string `json:"go_version"`
	Git_commit string `json:"git_commit"`
	Built      int64  `json:"built"`
	Os_arch    string `json:"os_arch"`
}

type NotImplemented struct {
	Comment string `json:"comment"`
}

type StringResponse struct {
	Message string `json:"message"`
}

// ContainerChanges describes the return struct for ListContainerChanges
type ContainerChanges struct {
	Changed []string `json:"changed"`
	Added   []string `json:"added"`
	Deleted []string `json:"deleted"`
}

// ImageInList describes the structure that is returned in
// ListImages.
type ImageInList struct {
	Id          string            `json:"id"`
	ParentId    string            `json:"parentId"`
	RepoTags    []string          `json:"repoTags"`
	RepoDigests []string          `json:"repoDigests"`
	Created     string            `json:"created"`
	Size        int64             `json:"size"`
	VirtualSize int64             `json:"virtualSize"`
	Containers  int64             `json:"containers"`
	Labels      map[string]string `json:"labels"`
}

// ImageHistory describes the returned structure from ImageHistory.
type ImageHistory struct {
	Id        string   `json:"id"`
	Created   string   `json:"created"`
	CreatedBy string   `json:"createdBy"`
	Tags      []string `json:"tags"`
	Size      int64    `json:"size"`
	Comment   string   `json:"comment"`
}

// ImageSearch is the returned structure for SearchImage.  It is returned
// in array form.
type ImageSearch struct {
	Description  string `json:"description"`
	Is_official  bool   `json:"is_official"`
	Is_automated bool   `json:"is_automated"`
	Name         string `json:"name"`
	Star_count   int64  `json:"star_count"`
}

// ListContainer is the returned struct for an individual container
type ListContainerData struct {
	Id               string                  `json:"id"`
	Image            string                  `json:"image"`
	Imageid          string                  `json:"imageid"`
	Command          []string                `json:"command"`
	Createdat        string                  `json:"createdat"`
	Runningfor       string                  `json:"runningfor"`
	Status           string                  `json:"status"`
	Ports            []ContainerPortMappings `json:"ports"`
	Rootfssize       int64                   `json:"rootfssize"`
	Rwsize           int64                   `json:"rwsize"`
	Names            string                  `json:"names"`
	Labels           map[string]string       `json:"labels"`
	Mounts           []ContainerMount        `json:"mounts"`
	Containerrunning bool                    `json:"containerrunning"`
	Namespaces       ContainerNameSpace      `json:"namespaces"`
}

// ContainerStats is the return struct for the stats of a container
type ContainerStats struct {
	Id           string  `json:"id"`
	Name         string  `json:"name"`
	Cpu          float64 `json:"cpu"`
	Cpu_nano     int64   `json:"cpu_nano"`
	System_nano  int64   `json:"system_nano"`
	Mem_usage    int64   `json:"mem_usage"`
	Mem_limit    int64   `json:"mem_limit"`
	Mem_perc     float64 `json:"mem_perc"`
	Net_input    int64   `json:"net_input"`
	Net_output   int64   `json:"net_output"`
	Block_output int64   `json:"block_output"`
	Block_input  int64   `json:"block_input"`
	Pids         int64   `json:"pids"`
}

// ContainerMount describes the struct for mounts in a container
type ContainerMount struct {
	Destination string   `json:"destination"`
	Type        string   `json:"type"`
	Source      string   `json:"source"`
	Options     []string `json:"options"`
}

// ContainerPortMappings describes the struct for portmappings in an existing container
type ContainerPortMappings struct {
	Host_port      string `json:"host_port"`
	Host_ip        string `json:"host_ip"`
	Protocol       string `json:"protocol"`
	Container_port string `json:"container_port"`
}

// ContainerNamespace describes the namespace structure for an existing container
type ContainerNameSpace struct {
	User   string `json:"user"`
	Uts    string `json:"uts"`
	Pidns  string `json:"pidns"`
	Pid    string `json:"pid"`
	Cgroup string `json:"cgroup"`
	Net    string `json:"net"`
	Mnt    string `json:"mnt"`
	Ipc    string `json:"ipc"`
}

// InfoDistribution describes the the host's distribution
type InfoDistribution struct {
	Distribution string `json:"distribution"`
	Version      string `json:"version"`
}

// InfoHost describes the host stats portion of PodmanInfo
type InfoHost struct {
	Buildah_version string           `json:"buildah_version"`
	Distribution    InfoDistribution `json:"distribution"`
	Mem_free        int64            `json:"mem_free"`
	Mem_total       int64            `json:"mem_total"`
	Swap_free       int64            `json:"swap_free"`
	Swap_total      int64            `json:"swap_total"`
	Arch            string           `json:"arch"`
	Cpus            int64            `json:"cpus"`
	Hostname        string           `json:"hostname"`
	Kernel          string           `json:"kernel"`
	Os              string           `json:"os"`
	Uptime          string           `json:"uptime"`
}

// InfoGraphStatus describes the detailed status of the storage driver
type InfoGraphStatus struct {
	Backing_filesystem  string `json:"backing_filesystem"`
	Native_overlay_diff string `json:"native_overlay_diff"`
	Supports_d_type     string `json:"supports_d_type"`
}

// InfoStore describes the host's storage informatoin
type InfoStore struct {
	Containers           int64           `json:"containers"`
	Images               int64           `json:"images"`
	Graph_driver_name    string          `json:"graph_driver_name"`
	Graph_driver_options string          `json:"graph_driver_options"`
	Graph_root           string          `json:"graph_root"`
	Graph_status         InfoGraphStatus `json:"graph_status"`
	Run_root             string          `json:"run_root"`
}

// InfoPodman provides details on the podman binary
type InfoPodmanBinary struct {
	Compiler       string `json:"compiler"`
	Go_version     string `json:"go_version"`
	Podman_version string `json:"podman_version"`
	Git_commit     string `json:"git_commit"`
}

// PodmanInfo describes the Podman host and build
type PodmanInfo struct {
	Host                InfoHost         `json:"host"`
	Registries          []string         `json:"registries"`
	Insecure_registries []string         `json:"insecure_registries"`
	Store               InfoStore        `json:"store"`
	Podman              InfoPodmanBinary `json:"podman"`
}

// Sockets describes sockets location for a container
type Sockets struct {
	Container_id   string `json:"container_id"`
	Io_socket      string `json:"io_socket"`
	Control_socket string `json:"control_socket"`
}

// Create is an input structure for creating containers. It closely resembles the
// CreateConfig structure in libpod/pkg/spec.
type Create struct {
	Args                 []string             `json:"args"`
	Cap_add              []string             `json:"cap_add"`
	Cap_drop             []string             `json:"cap_drop"`
	Conmon_pidfile       string               `json:"conmon_pidfile"`
	Cgroup_parent        string               `json:"cgroup_parent"`
	Command              []string             `json:"command"`
	Detach               bool                 `json:"detach"`
	Devices              []string             `json:"devices"`
	Dns_opt              []string             `json:"dns_opt"`
	Dns_search           []string             `json:"dns_search"`
	Dns_servers          []string             `json:"dns_servers"`
	Entrypoint           []string             `json:"entrypoint"`
	Env                  map[string]string    `json:"env"`
	Exposed_ports        []string             `json:"exposed_ports"`
	Gidmap               []string             `json:"gidmap"`
	Group_add            []string             `json:"group_add"`
	Host_add             []string             `json:"host_add"`
	Hostname             string               `json:"hostname"`
	Image                string               `json:"image"`
	Image_id             string               `json:"image_id"`
	Builtin_imgvolumes   []string             `json:"builtin_imgvolumes"`
	Id_mappings          IDMappingOptions     `json:"id_mappings"`
	Image_volume_type    string               `json:"image_volume_type"`
	Interactive          bool                 `json:"interactive"`
	Ipc_mode             string               `json:"ipc_mode"`
	Labels               map[string]string    `json:"labels"`
	Log_driver           string               `json:"log_driver"`
	Log_driver_opt       []string             `json:"log_driver_opt"`
	Name                 string               `json:"name"`
	Net_mode             string               `json:"net_mode"`
	Network              string               `json:"network"`
	Pid_mode             string               `json:"pid_mode"`
	Pod                  string               `json:"pod"`
	Privileged           bool                 `json:"privileged"`
	Publish              []string             `json:"publish"`
	Publish_all          bool                 `json:"publish_all"`
	Quiet                bool                 `json:"quiet"`
	Readonly_rootfs      bool                 `json:"readonly_rootfs"`
	Resources            CreateResourceConfig `json:"resources"`
	Rm                   bool                 `json:"rm"`
	Shm_dir              string               `json:"shm_dir"`
	Stop_signal          int64                `json:"stop_signal"`
	Stop_timeout         int64                `json:"stop_timeout"`
	Subuidmap            string               `json:"subuidmap"`
	Subgidmap            string               `json:"subgidmap"`
	Subuidname           string               `json:"subuidname"`
	Subgidname           string               `json:"subgidname"`
	Sys_ctl              map[string]string    `json:"sys_ctl"`
	Tmpfs                []string             `json:"tmpfs"`
	Tty                  bool                 `json:"tty"`
	Uidmap               []string             `json:"uidmap"`
	Userns_mode          string               `json:"userns_mode"`
	User                 string               `json:"user"`
	Uts_mode             string               `json:"uts_mode"`
	Volumes              []string             `json:"volumes"`
	Work_dir             string               `json:"work_dir"`
	Mount_label          string               `json:"mount_label"`
	Process_label        string               `json:"process_label"`
	No_new_privs         bool                 `json:"no_new_privs"`
	Apparmor_profile     string               `json:"apparmor_profile"`
	Seccomp_profile_path string               `json:"seccomp_profile_path"`
	Security_opts        []string             `json:"security_opts"`
}

// CreateResourceConfig is an input structure used to describe host attributes during
// container creation.  It is only valid inside a [Create](#Create) type.
type CreateResourceConfig struct {
	Blkio_weight        int64    `json:"blkio_weight"`
	Blkio_weight_device []string `json:"blkio_weight_device"`
	Cpu_period          int64    `json:"cpu_period"`
	Cpu_quota           int64    `json:"cpu_quota"`
	Cpu_rt_period       int64    `json:"cpu_rt_period"`
	Cpu_rt_runtime      int64    `json:"cpu_rt_runtime"`
	Cpu_shares          int64    `json:"cpu_shares"`
	Cpus                float64  `json:"cpus"`
	Cpuset_cpus         string   `json:"cpuset_cpus"`
	Cpuset_mems         string   `json:"cpuset_mems"`
	Device_read_bps     []string `json:"device_read_bps"`
	Device_read_iops    []string `json:"device_read_iops"`
	Device_write_bps    []string `json:"device_write_bps"`
	Device_write_iops   []string `json:"device_write_iops"`
	Disable_oomkiller   bool     `json:"disable_oomkiller"`
	Kernel_memory       int64    `json:"kernel_memory"`
	Memory              int64    `json:"memory"`
	Memory_reservation  int64    `json:"memory_reservation"`
	Memory_swap         int64    `json:"memory_swap"`
	Memory_swappiness   int64    `json:"memory_swappiness"`
	Oom_score_adj       int64    `json:"oom_score_adj"`
	Pids_limit          int64    `json:"pids_limit"`
	Shm_size            int64    `json:"shm_size"`
	Ulimit              []string `json:"ulimit"`
}

// IDMappingOptions is an input structure used to described ids during container creation.
type IDMappingOptions struct {
	Host_uid_mapping bool  `json:"host_uid_mapping"`
	Host_gid_mapping bool  `json:"host_gid_mapping"`
	Uid_map          IDMap `json:"uid_map"`
	Gid_map          IDMap `json:"gid_map"`
}

// IDMap is used to describe user name spaces during container creation
type IDMap struct {
	Container_id int64 `json:"container_id"`
	Host_id      int64 `json:"host_id"`
	Size         int64 `json:"size"`
}

// BuildInfo is used to describe user input for building images
type BuildInfo struct {
	Dockerfile    []string          `json:"dockerfile"`
	Tags          []string          `json:"tags"`
	Add_hosts     []string          `json:"add_hosts"`
	Cgroup_parent string            `json:"cgroup_parent"`
	Cpu_period    int64             `json:"cpu_period"`
	Cpu_quota     int64             `json:"cpu_quota"`
	Cpu_shares    int64             `json:"cpu_shares"`
	Cpuset_cpus   string            `json:"cpuset_cpus"`
	Cpuset_mems   string            `json:"cpuset_mems"`
	Memory        string            `json:"memory"`
	Memory_swap   string            `json:"memory_swap"`
	Security_opts []string          `json:"security_opts"`
	Shm_size      string            `json:"shm_size"`
	Ulimit        []string          `json:"ulimit"`
	Volume        []string          `json:"volume"`
	Squash        bool              `json:"squash"`
	Pull          bool              `json:"pull"`
	Pull_always   bool              `json:"pull_always"`
	Force_rm      bool              `json:"force_rm"`
	Rm            bool              `json:"rm"`
	Label         []string          `json:"label"`
	Annotations   []string          `json:"annotations"`
	Build_args    map[string]string `json:"build_args"`
	Image_format  string            `json:"image_format"`
}

// BuildResponse is used to describe the responses for building images
type BuildResponse struct {
	Logs []string `json:"logs"`
	Id   string   `json:"id"`
}

// ListPodContainerInfo is a returned struct for describing containers
// in a pod.
type ListPodContainerInfo struct {
	Name   string `json:"name"`
	Id     string `json:"id"`
	Status string `json:"status"`
}

// PodCreate is an input structure for creating pods.
// It emulates options to podman pod create, however
// changing pause image name and pause container
// is not currently supported
type PodCreate struct {
	Name         string            `json:"name"`
	CgroupParent string            `json:"cgroupParent"`
	Labels       map[string]string `json:"labels"`
	Share        []string          `json:"share"`
	Infra        bool              `json:"infra"`
}

// ListPodData is the returned struct for an individual pod
type ListPodData struct {
	Id                 string                 `json:"id"`
	Name               string                 `json:"name"`
	Createdat          string                 `json:"createdat"`
	Cgroup             string                 `json:"cgroup"`
	Status             string                 `json:"status"`
	Labels             map[string]string      `json:"labels"`
	Numberofcontainers string                 `json:"numberofcontainers"`
	Containersinfo     []ListPodContainerInfo `json:"containersinfo"`
}

type PodContainerErrorData struct {
	Containerid string `json:"containerid"`
	Reason      string `json:"reason"`
}

// Generated client method calls

// Ping provides a response for developers to ensure their varlink setup is working.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.Ping
// {
//   "ping": {
//     "message": "OK"
//   }
// }
// ~~~
type Ping_methods struct{}

func Ping() Ping_methods { return Ping_methods{} }

func (m Ping_methods) Call(c *varlink.Connection) (ping_out_ StringResponse, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	ping_out_, _, err_ = receive()
	return
}

func (m Ping_methods) Send(c *varlink.Connection, flags uint64) (func() (StringResponse, uint64, error), error) {
	receive, err := c.Send("io.podman.Ping", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (ping_out_ StringResponse, flags uint64, err error) {
		var out struct {
			Ping StringResponse `json:"ping"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		ping_out_ = out.Ping
		return
	}, nil
}

// GetVersion returns a Version structure describing the libpod setup on their
// system.
type GetVersion_methods struct{}

func GetVersion() GetVersion_methods { return GetVersion_methods{} }

func (m GetVersion_methods) Call(c *varlink.Connection) (version_out_ Version, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	version_out_, _, err_ = receive()
	return
}

func (m GetVersion_methods) Send(c *varlink.Connection, flags uint64) (func() (Version, uint64, error), error) {
	receive, err := c.Send("io.podman.GetVersion", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (version_out_ Version, flags uint64, err error) {
		var out struct {
			Version Version `json:"version"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		version_out_ = out.Version
		return
	}, nil
}

// GetInfo returns a [PodmanInfo](#PodmanInfo) struct that describes podman and its host such as storage stats,
// build information of Podman, and system-wide registries.
type GetInfo_methods struct{}

func GetInfo() GetInfo_methods { return GetInfo_methods{} }

func (m GetInfo_methods) Call(c *varlink.Connection) (info_out_ PodmanInfo, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	info_out_, _, err_ = receive()
	return
}

func (m GetInfo_methods) Send(c *varlink.Connection, flags uint64) (func() (PodmanInfo, uint64, error), error) {
	receive, err := c.Send("io.podman.GetInfo", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (info_out_ PodmanInfo, flags uint64, err error) {
		var out struct {
			Info PodmanInfo `json:"info"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		info_out_ = out.Info
		return
	}, nil
}

// ListContainers returns a list of containers in no particular order.  There are
// returned as an array of ListContainerData structs.  See also [GetContainer](#GetContainer).
type ListContainers_methods struct{}

func ListContainers() ListContainers_methods { return ListContainers_methods{} }

func (m ListContainers_methods) Call(c *varlink.Connection) (containers_out_ []ListContainerData, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	containers_out_, _, err_ = receive()
	return
}

func (m ListContainers_methods) Send(c *varlink.Connection, flags uint64) (func() ([]ListContainerData, uint64, error), error) {
	receive, err := c.Send("io.podman.ListContainers", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (containers_out_ []ListContainerData, flags uint64, err error) {
		var out struct {
			Containers []ListContainerData `json:"containers"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		containers_out_ = []ListContainerData(out.Containers)
		return
	}, nil
}

// GetContainer takes a name or ID of a container and returns single ListContainerData
// structure.  A [ContainerNotFound](#ContainerNotFound) error will be returned if the container cannot be found.
// See also [ListContainers](ListContainers) and [InspectContainer](#InspectContainer).
type GetContainer_methods struct{}

func GetContainer() GetContainer_methods { return GetContainer_methods{} }

func (m GetContainer_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ ListContainerData, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m GetContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (ListContainerData, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ ListContainerData, flags uint64, err error) {
		var out struct {
			Container ListContainerData `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// CreateContainer creates a new container from an image.  It uses a [Create](#Create) type for input. The minimum
// input required for CreateContainer is an image name.  If the image name is not found, an [ImageNotFound](#ImageNotFound)
// error will be returned.  Otherwise, the ID of the newly created container will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.CreateContainer '{"create": {"image": "alpine"}}'
// {
//   "container": "8759dafbc0a4dc3bcfb57eeb72e4331eb73c5cc09ab968e65ce45b9ad5c4b6bb"
// }
// ~~~
type CreateContainer_methods struct{}

func CreateContainer() CreateContainer_methods { return CreateContainer_methods{} }

func (m CreateContainer_methods) Call(c *varlink.Connection, create_in_ Create) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, create_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m CreateContainer_methods) Send(c *varlink.Connection, flags uint64, create_in_ Create) (func() (string, uint64, error), error) {
	var in struct {
		Create Create `json:"create"`
	}
	in.Create = create_in_
	receive, err := c.Send("io.podman.CreateContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// InspectContainer data takes a name or ID of a container returns the inspection
// data in string format.  You can then serialize the string into JSON.  A [ContainerNotFound](#ContainerNotFound)
// error will be returned if the container cannot be found. See also [InspectImage](#InspectImage).
type InspectContainer_methods struct{}

func InspectContainer() InspectContainer_methods { return InspectContainer_methods{} }

func (m InspectContainer_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m InspectContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.InspectContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// ListContainerProcesses takes a name or ID of a container and returns the processes
// running inside the container as array of strings.  It will accept an array of string
// arguments that represent ps options.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.ListContainerProcesses '{"name": "135d71b9495f", "opts": []}'
// {
//   "container": [
//     "  UID   PID  PPID  C STIME TTY          TIME CMD",
//     "    0 21220 21210  0 09:05 pts/0    00:00:00 /bin/sh",
//     "    0 21232 21220  0 09:05 pts/0    00:00:00 top",
//     "    0 21284 21220  0 09:05 pts/0    00:00:00 vi /etc/hosts"
//   ]
// }
// ~~~
type ListContainerProcesses_methods struct{}

func ListContainerProcesses() ListContainerProcesses_methods { return ListContainerProcesses_methods{} }

func (m ListContainerProcesses_methods) Call(c *varlink.Connection, name_in_ string, opts_in_ []string) (container_out_ []string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, opts_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m ListContainerProcesses_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, opts_in_ []string) (func() ([]string, uint64, error), error) {
	var in struct {
		Name string   `json:"name"`
		Opts []string `json:"opts"`
	}
	in.Name = name_in_
	in.Opts = []string(opts_in_)
	receive, err := c.Send("io.podman.ListContainerProcesses", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ []string, flags uint64, err error) {
		var out struct {
			Container []string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = []string(out.Container)
		return
	}, nil
}

// GetContainerLogs takes a name or ID of a container and returns the logs of that container.
// If the container cannot be found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// The container logs are returned as an array of strings.  GetContainerLogs will honor the streaming
// capability of varlink if the client invokes it.
type GetContainerLogs_methods struct{}

func GetContainerLogs() GetContainerLogs_methods { return GetContainerLogs_methods{} }

func (m GetContainerLogs_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ []string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m GetContainerLogs_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() ([]string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetContainerLogs", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ []string, flags uint64, err error) {
		var out struct {
			Container []string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = []string(out.Container)
		return
	}, nil
}

// ListContainerChanges takes a name or ID of a container and returns changes between the container and
// its base image. It returns a struct of changed, deleted, and added path names.
type ListContainerChanges_methods struct{}

func ListContainerChanges() ListContainerChanges_methods { return ListContainerChanges_methods{} }

func (m ListContainerChanges_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ ContainerChanges, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m ListContainerChanges_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (ContainerChanges, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.ListContainerChanges", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ ContainerChanges, flags uint64, err error) {
		var out struct {
			Container ContainerChanges `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// ExportContainer creates an image from a container.  It takes the name or ID of a container and a
// path representing the target tarfile.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.
// The return value is the written tarfile.
type ExportContainer_methods struct{}

func ExportContainer() ExportContainer_methods { return ExportContainer_methods{} }

func (m ExportContainer_methods) Call(c *varlink.Connection, name_in_ string, path_in_ string) (tarfile_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, path_in_)
	if err_ != nil {
		return
	}
	tarfile_out_, _, err_ = receive()
	return
}

func (m ExportContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, path_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
		Path string `json:"path"`
	}
	in.Name = name_in_
	in.Path = path_in_
	receive, err := c.Send("io.podman.ExportContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (tarfile_out_ string, flags uint64, err error) {
		var out struct {
			Tarfile string `json:"tarfile"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		tarfile_out_ = out.Tarfile
		return
	}, nil
}

// GetContainerStats takes the name or ID of a container and returns a single ContainerStats structure which
// contains attributes like memory and cpu usage.  If the container cannot be found, a
// [ContainerNotFound](#ContainerNotFound) error will be returned. If the container is not running, a [NoContainerRunning](#NoContainerRunning)
// error will be returned
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.GetContainerStats '{"name": "c33e4164f384"}'
// {
//   "container": {
//     "block_input": 0,
//     "block_output": 0,
//     "cpu": 2.571123918839990154678e-08,
//     "cpu_nano": 49037378,
//     "id": "c33e4164f384aa9d979072a63319d66b74fd7a128be71fa68ede24f33ec6cfee",
//     "mem_limit": 33080606720,
//     "mem_perc": 2.166828456524753747370e-03,
//     "mem_usage": 716800,
//     "name": "competent_wozniak",
//     "net_input": 768,
//     "net_output": 5910,
//     "pids": 1,
//     "system_nano": 10000000
//   }
// }
// ~~~
type GetContainerStats_methods struct{}

func GetContainerStats() GetContainerStats_methods { return GetContainerStats_methods{} }

func (m GetContainerStats_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ ContainerStats, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m GetContainerStats_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (ContainerStats, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetContainerStats", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ ContainerStats, flags uint64, err error) {
		var out struct {
			Container ContainerStats `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// This method has not be implemented yet.
type ResizeContainerTty_methods struct{}

func ResizeContainerTty() ResizeContainerTty_methods { return ResizeContainerTty_methods{} }

func (m ResizeContainerTty_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m ResizeContainerTty_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.ResizeContainerTty", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// StartContainer starts a created or stopped container. It takes the name or ID of container.  It returns
// the container ID once started.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.  See also [CreateContainer](#CreateContainer).
type StartContainer_methods struct{}

func StartContainer() StartContainer_methods { return StartContainer_methods{} }

func (m StartContainer_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m StartContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.StartContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// StopContainer stops a container given a timeout.  It takes the name or ID of a container as well as a
// timeout value.  The timeout value the time before a forcible stop to the container is applied.  It
// returns the container ID once stopped. If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned instead. See also [KillContainer](KillContainer).
// #### Error
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StopContainer '{"name": "135d71b9495f", "timeout": 5}'
// {
//   "container": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
type StopContainer_methods struct{}

func StopContainer() StopContainer_methods { return StopContainer_methods{} }

func (m StopContainer_methods) Call(c *varlink.Connection, name_in_ string, timeout_in_ int64) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, timeout_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m StopContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, timeout_in_ int64) (func() (string, uint64, error), error) {
	var in struct {
		Name    string `json:"name"`
		Timeout int64  `json:"timeout"`
	}
	in.Name = name_in_
	in.Timeout = timeout_in_
	receive, err := c.Send("io.podman.StopContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// RestartContainer will restart a running container given a container name or ID and timeout value. The timeout
// value is the time before a forcible stop is used to stop the container.  If the container cannot be found by
// name or ID, a [ContainerNotFound](#ContainerNotFound)  error will be returned; otherwise, the ID of the
// container will be returned.
type RestartContainer_methods struct{}

func RestartContainer() RestartContainer_methods { return RestartContainer_methods{} }

func (m RestartContainer_methods) Call(c *varlink.Connection, name_in_ string, timeout_in_ int64) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, timeout_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m RestartContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, timeout_in_ int64) (func() (string, uint64, error), error) {
	var in struct {
		Name    string `json:"name"`
		Timeout int64  `json:"timeout"`
	}
	in.Name = name_in_
	in.Timeout = timeout_in_
	receive, err := c.Send("io.podman.RestartContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// KillContainer takes the name or ID of a container as well as a signal to be applied to the container.  Once the
// container has been killed, the container's ID is returned.  If the container cannot be found, a
// [ContainerNotFound](#ContainerNotFound) error is returned. See also [StopContainer](StopContainer).
type KillContainer_methods struct{}

func KillContainer() KillContainer_methods { return KillContainer_methods{} }

func (m KillContainer_methods) Call(c *varlink.Connection, name_in_ string, signal_in_ int64) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, signal_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m KillContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, signal_in_ int64) (func() (string, uint64, error), error) {
	var in struct {
		Name   string `json:"name"`
		Signal int64  `json:"signal"`
	}
	in.Name = name_in_
	in.Signal = signal_in_
	receive, err := c.Send("io.podman.KillContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// This method has not be implemented yet.
type UpdateContainer_methods struct{}

func UpdateContainer() UpdateContainer_methods { return UpdateContainer_methods{} }

func (m UpdateContainer_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m UpdateContainer_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.UpdateContainer", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// This method has not be implemented yet.
type RenameContainer_methods struct{}

func RenameContainer() RenameContainer_methods { return RenameContainer_methods{} }

func (m RenameContainer_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m RenameContainer_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.RenameContainer", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// PauseContainer takes the name or ID of container and pauses it.  If the container cannot be found,
// a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
// See also [UnpauseContainer](#UnpauseContainer).
type PauseContainer_methods struct{}

func PauseContainer() PauseContainer_methods { return PauseContainer_methods{} }

func (m PauseContainer_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m PauseContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.PauseContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// UnpauseContainer takes the name or ID of container and unpauses a paused container.  If the container cannot be
// found, a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
// See also [PauseContainer](#PauseContainer).
type UnpauseContainer_methods struct{}

func UnpauseContainer() UnpauseContainer_methods { return UnpauseContainer_methods{} }

func (m UnpauseContainer_methods) Call(c *varlink.Connection, name_in_ string) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m UnpauseContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.UnpauseContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// This method has not be implemented yet.
type AttachToContainer_methods struct{}

func AttachToContainer() AttachToContainer_methods { return AttachToContainer_methods{} }

func (m AttachToContainer_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m AttachToContainer_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.AttachToContainer", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// GetAttachSockets takes the name or ID of an existing container.  It returns file paths for two sockets needed
// to properly communicate with a container.  The first is the actual I/O socket that the container uses.  The
// second is a "control" socket where things like resizing the TTY events are sent. If the container cannot be
// found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/io.podman/io.podman.GetAttachSockets '{"name": "b7624e775431219161"}'
// {
//   "sockets": {
//     "container_id": "b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca",
//     "control_socket": "/var/lib/containers/storage/overlay-containers/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/userdata/ctl",
//     "io_socket": "/var/run/libpod/socket/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/attach"
//   }
// }
// ~~~
type GetAttachSockets_methods struct{}

func GetAttachSockets() GetAttachSockets_methods { return GetAttachSockets_methods{} }

func (m GetAttachSockets_methods) Call(c *varlink.Connection, name_in_ string) (sockets_out_ Sockets, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	sockets_out_, _, err_ = receive()
	return
}

func (m GetAttachSockets_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (Sockets, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetAttachSockets", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (sockets_out_ Sockets, flags uint64, err error) {
		var out struct {
			Sockets Sockets `json:"sockets"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		sockets_out_ = out.Sockets
		return
	}, nil
}

// WaitContainer takes the name or ID of a container and waits until the container stops.  Upon stopping, the return
// code of the container is returned. If the container container cannot be found by ID or name,
// a [ContainerNotFound](#ContainerNotFound) error is returned.
type WaitContainer_methods struct{}

func WaitContainer() WaitContainer_methods { return WaitContainer_methods{} }

func (m WaitContainer_methods) Call(c *varlink.Connection, name_in_ string) (exitcode_out_ int64, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	exitcode_out_, _, err_ = receive()
	return
}

func (m WaitContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (int64, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.WaitContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (exitcode_out_ int64, flags uint64, err error) {
		var out struct {
			Exitcode int64 `json:"exitcode"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		exitcode_out_ = out.Exitcode
		return
	}, nil
}

// RemoveContainer takes requires the name or ID of container as well a boolean representing whether a running
// container can be stopped and removed.  Upon successful removal of the container, its ID is returned.  If the
// container cannot be found by name or ID, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RemoveContainer '{"name": "62f4fd98cb57"}'
// {
//   "container": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
// }
// ~~~
type RemoveContainer_methods struct{}

func RemoveContainer() RemoveContainer_methods { return RemoveContainer_methods{} }

func (m RemoveContainer_methods) Call(c *varlink.Connection, name_in_ string, force_in_ bool) (container_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, force_in_)
	if err_ != nil {
		return
	}
	container_out_, _, err_ = receive()
	return
}

func (m RemoveContainer_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, force_in_ bool) (func() (string, uint64, error), error) {
	var in struct {
		Name  string `json:"name"`
		Force bool   `json:"force"`
	}
	in.Name = name_in_
	in.Force = force_in_
	receive, err := c.Send("io.podman.RemoveContainer", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (container_out_ string, flags uint64, err error) {
		var out struct {
			Container string `json:"container"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		container_out_ = out.Container
		return
	}, nil
}

// DeleteStoppedContainers will delete all containers that are not running. It will return a list the deleted
// container IDs.  See also [RemoveContainer](RemoveContainer).
type DeleteStoppedContainers_methods struct{}

func DeleteStoppedContainers() DeleteStoppedContainers_methods {
	return DeleteStoppedContainers_methods{}
}

func (m DeleteStoppedContainers_methods) Call(c *varlink.Connection) (containers_out_ []string, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	containers_out_, _, err_ = receive()
	return
}

func (m DeleteStoppedContainers_methods) Send(c *varlink.Connection, flags uint64) (func() ([]string, uint64, error), error) {
	receive, err := c.Send("io.podman.DeleteStoppedContainers", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (containers_out_ []string, flags uint64, err error) {
		var out struct {
			Containers []string `json:"containers"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		containers_out_ = []string(out.Containers)
		return
	}, nil
}

// ListImages returns an array of ImageInList structures which provide basic information about
// an image currently in storage.  See also [InspectImage](InspectImage).
type ListImages_methods struct{}

func ListImages() ListImages_methods { return ListImages_methods{} }

func (m ListImages_methods) Call(c *varlink.Connection) (images_out_ []ImageInList, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	images_out_, _, err_ = receive()
	return
}

func (m ListImages_methods) Send(c *varlink.Connection, flags uint64) (func() ([]ImageInList, uint64, error), error) {
	receive, err := c.Send("io.podman.ListImages", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (images_out_ []ImageInList, flags uint64, err error) {
		var out struct {
			Images []ImageInList `json:"images"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		images_out_ = []ImageInList(out.Images)
		return
	}, nil
}

// GetImage returns a single image in an [ImageInList](#ImageInList) struct.  You must supply an image name as a string.
// If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.
type GetImage_methods struct{}

func GetImage() GetImage_methods { return GetImage_methods{} }

func (m GetImage_methods) Call(c *varlink.Connection, name_in_ string) (image_out_ ImageInList, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m GetImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (ImageInList, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ ImageInList, flags uint64, err error) {
		var out struct {
			Image ImageInList `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// BuildImage takes a [BuildInfo](#BuildInfo) structure and builds an image.  At a minimum, you must provide the
// 'dockerfile' and 'tags' options in the BuildInfo structure. It will return a [BuildResponse](#BuildResponse) structure
// that contains the build logs and resulting image ID.
type BuildImage_methods struct{}

func BuildImage() BuildImage_methods { return BuildImage_methods{} }

func (m BuildImage_methods) Call(c *varlink.Connection, build_in_ BuildInfo) (image_out_ BuildResponse, err_ error) {
	receive, err_ := m.Send(c, 0, build_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m BuildImage_methods) Send(c *varlink.Connection, flags uint64, build_in_ BuildInfo) (func() (BuildResponse, uint64, error), error) {
	var in struct {
		Build BuildInfo `json:"build"`
	}
	in.Build = build_in_
	receive, err := c.Send("io.podman.BuildImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ BuildResponse, flags uint64, err error) {
		var out struct {
			Image BuildResponse `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// This function is not implemented yet.
type CreateImage_methods struct{}

func CreateImage() CreateImage_methods { return CreateImage_methods{} }

func (m CreateImage_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m CreateImage_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.CreateImage", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// InspectImage takes the name or ID of an image and returns a string respresentation of data associated with the
// mage.  You must serialize the string into JSON to use it further.  An [ImageNotFound](#ImageNotFound) error will
// be returned if the image cannot be found.
type InspectImage_methods struct{}

func InspectImage() InspectImage_methods { return InspectImage_methods{} }

func (m InspectImage_methods) Call(c *varlink.Connection, name_in_ string) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m InspectImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.InspectImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// HistoryImage takes the name or ID of an image and returns information about its history and layers.  The returned
// history is in the form of an array of ImageHistory structures.  If the image cannot be found, an
// [ImageNotFound](#ImageNotFound) error is returned.
type HistoryImage_methods struct{}

func HistoryImage() HistoryImage_methods { return HistoryImage_methods{} }

func (m HistoryImage_methods) Call(c *varlink.Connection, name_in_ string) (history_out_ []ImageHistory, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	history_out_, _, err_ = receive()
	return
}

func (m HistoryImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() ([]ImageHistory, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.HistoryImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (history_out_ []ImageHistory, flags uint64, err error) {
		var out struct {
			History []ImageHistory `json:"history"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		history_out_ = []ImageHistory(out.History)
		return
	}, nil
}

// PushImage takes three input arguments: the name or ID of an image, the fully-qualified destination name of the image,
// and a boolean as to whether tls-verify should be used.  It will return an [ImageNotFound](#ImageNotFound) error if
// the image cannot be found in local storage; otherwise the ID of the image will be returned on success.
type PushImage_methods struct{}

func PushImage() PushImage_methods { return PushImage_methods{} }

func (m PushImage_methods) Call(c *varlink.Connection, name_in_ string, tag_in_ string, tlsverify_in_ bool) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, tag_in_, tlsverify_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m PushImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, tag_in_ string, tlsverify_in_ bool) (func() (string, uint64, error), error) {
	var in struct {
		Name      string `json:"name"`
		Tag       string `json:"tag"`
		Tlsverify bool   `json:"tlsverify"`
	}
	in.Name = name_in_
	in.Tag = tag_in_
	in.Tlsverify = tlsverify_in_
	receive, err := c.Send("io.podman.PushImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// TagImage takes the name or ID of an image in local storage as well as the desired tag name.  If the image cannot
// be found, an [ImageNotFound](#ImageNotFound) error will be returned; otherwise, the ID of the image is returned on success.
type TagImage_methods struct{}

func TagImage() TagImage_methods { return TagImage_methods{} }

func (m TagImage_methods) Call(c *varlink.Connection, name_in_ string, tagged_in_ string) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, tagged_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m TagImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, tagged_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name   string `json:"name"`
		Tagged string `json:"tagged"`
	}
	in.Name = name_in_
	in.Tagged = tagged_in_
	receive, err := c.Send("io.podman.TagImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// RemoveImage takes the name or ID of an image as well as a boolean that determines if containers using that image
// should be deleted.  If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.  The
// ID of the removed image is returned when complete.  See also [DeleteUnusedImages](DeleteUnusedImages).
// #### Example
// ~~~
// varlink call -m unix:/run/podman/io.podman/io.podman.RemoveImage '{"name": "registry.fedoraproject.org/fedora", "force": true}'
// {
//   "image": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
// }
// ~~~
type RemoveImage_methods struct{}

func RemoveImage() RemoveImage_methods { return RemoveImage_methods{} }

func (m RemoveImage_methods) Call(c *varlink.Connection, name_in_ string, force_in_ bool) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, force_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m RemoveImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, force_in_ bool) (func() (string, uint64, error), error) {
	var in struct {
		Name  string `json:"name"`
		Force bool   `json:"force"`
	}
	in.Name = name_in_
	in.Force = force_in_
	receive, err := c.Send("io.podman.RemoveImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// SearchImage takes the string of an image name and a limit of searches from each registries to be returned.  SearchImage
// will then use a glob-like match to find the image you are searching for.  The images are returned in an array of
// ImageSearch structures which contain information about the image as well as its fully-qualified name.
type SearchImage_methods struct{}

func SearchImage() SearchImage_methods { return SearchImage_methods{} }

func (m SearchImage_methods) Call(c *varlink.Connection, name_in_ string, limit_in_ int64) (images_out_ []ImageSearch, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, limit_in_)
	if err_ != nil {
		return
	}
	images_out_, _, err_ = receive()
	return
}

func (m SearchImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, limit_in_ int64) (func() ([]ImageSearch, uint64, error), error) {
	var in struct {
		Name  string `json:"name"`
		Limit int64  `json:"limit"`
	}
	in.Name = name_in_
	in.Limit = limit_in_
	receive, err := c.Send("io.podman.SearchImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (images_out_ []ImageSearch, flags uint64, err error) {
		var out struct {
			Images []ImageSearch `json:"images"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		images_out_ = []ImageSearch(out.Images)
		return
	}, nil
}

// DeleteUnusedImages deletes any images not associated with a container.  The IDs of the deleted images are returned
// in a string array.
type DeleteUnusedImages_methods struct{}

func DeleteUnusedImages() DeleteUnusedImages_methods { return DeleteUnusedImages_methods{} }

func (m DeleteUnusedImages_methods) Call(c *varlink.Connection) (images_out_ []string, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	images_out_, _, err_ = receive()
	return
}

func (m DeleteUnusedImages_methods) Send(c *varlink.Connection, flags uint64) (func() ([]string, uint64, error), error) {
	receive, err := c.Send("io.podman.DeleteUnusedImages", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (images_out_ []string, flags uint64, err error) {
		var out struct {
			Images []string `json:"images"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		images_out_ = []string(out.Images)
		return
	}, nil
}

// Commit, creates an image from an existing container. It requires the name or
// ID of the container as well as the resulting image name.  Optionally, you can define an author and message
// to be added to the resulting image.  You can also define changes to the resulting image for the following
// attributes: _CMD, ENTRYPOINT, ENV, EXPOSE, LABEL, ONBUILD, STOPSIGNAL, USER, VOLUME, and WORKDIR_.  To pause the
// container while it is being committed, pass a _true_ bool for the pause argument.  If the container cannot
// be found by the ID or name provided, a (ContainerNotFound)[#ContainerNotFound] error will be returned; otherwise,
// the resulting image's ID will be returned as a string.
type Commit_methods struct{}

func Commit() Commit_methods { return Commit_methods{} }

func (m Commit_methods) Call(c *varlink.Connection, name_in_ string, image_name_in_ string, changes_in_ []string, author_in_ string, message_in_ string, pause_in_ bool, manifestType_in_ string) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, image_name_in_, changes_in_, author_in_, message_in_, pause_in_, manifestType_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m Commit_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, image_name_in_ string, changes_in_ []string, author_in_ string, message_in_ string, pause_in_ bool, manifestType_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name         string   `json:"name"`
		Image_name   string   `json:"image_name"`
		Changes      []string `json:"changes"`
		Author       string   `json:"author"`
		Message      string   `json:"message"`
		Pause        bool     `json:"pause"`
		ManifestType string   `json:"manifestType"`
	}
	in.Name = name_in_
	in.Image_name = image_name_in_
	in.Changes = []string(changes_in_)
	in.Author = author_in_
	in.Message = message_in_
	in.Pause = pause_in_
	in.ManifestType = manifestType_in_
	receive, err := c.Send("io.podman.Commit", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// ImportImage imports an image from a source (like tarball) into local storage.  The image can have additional
// descriptions added to it using the message and changes options. See also [ExportImage](ExportImage).
type ImportImage_methods struct{}

func ImportImage() ImportImage_methods { return ImportImage_methods{} }

func (m ImportImage_methods) Call(c *varlink.Connection, source_in_ string, reference_in_ string, message_in_ string, changes_in_ []string) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, source_in_, reference_in_, message_in_, changes_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m ImportImage_methods) Send(c *varlink.Connection, flags uint64, source_in_ string, reference_in_ string, message_in_ string, changes_in_ []string) (func() (string, uint64, error), error) {
	var in struct {
		Source    string   `json:"source"`
		Reference string   `json:"reference"`
		Message   string   `json:"message"`
		Changes   []string `json:"changes"`
	}
	in.Source = source_in_
	in.Reference = reference_in_
	in.Message = message_in_
	in.Changes = []string(changes_in_)
	receive, err := c.Send("io.podman.ImportImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// ExportImage takes the name or ID of an image and exports it to a destination like a tarball.  There is also
// a booleon option to force compression.  It also takes in a string array of tags to be able to save multiple
// tags of the same image to a tarball (each tag should be of the form <image>:<tag>).  Upon completion, the ID
// of the image is returned. If the image cannot be found in local storage, an [ImageNotFound](#ImageNotFound)
// error will be returned. See also [ImportImage](ImportImage).
type ExportImage_methods struct{}

func ExportImage() ExportImage_methods { return ExportImage_methods{} }

func (m ExportImage_methods) Call(c *varlink.Connection, name_in_ string, destination_in_ string, compress_in_ bool, tags_in_ []string) (image_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, destination_in_, compress_in_, tags_in_)
	if err_ != nil {
		return
	}
	image_out_, _, err_ = receive()
	return
}

func (m ExportImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, destination_in_ string, compress_in_ bool, tags_in_ []string) (func() (string, uint64, error), error) {
	var in struct {
		Name        string   `json:"name"`
		Destination string   `json:"destination"`
		Compress    bool     `json:"compress"`
		Tags        []string `json:"tags"`
	}
	in.Name = name_in_
	in.Destination = destination_in_
	in.Compress = compress_in_
	in.Tags = []string(tags_in_)
	receive, err := c.Send("io.podman.ExportImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (image_out_ string, flags uint64, err error) {
		var out struct {
			Image string `json:"image"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		image_out_ = out.Image
		return
	}, nil
}

// PullImage pulls an image from a repository to local storage.  After the pull is successful, the ID of the image
// is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.PullImage '{"name": "registry.fedoraproject.org/fedora"}'
// {
//   "id": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
// }
// ~~~
type PullImage_methods struct{}

func PullImage() PullImage_methods { return PullImage_methods{} }

func (m PullImage_methods) Call(c *varlink.Connection, name_in_ string) (id_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	id_out_, _, err_ = receive()
	return
}

func (m PullImage_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.PullImage", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (id_out_ string, flags uint64, err error) {
		var out struct {
			Id string `json:"id"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		id_out_ = out.Id
		return
	}, nil
}

// CreatePod creates a new empty pod.  It uses a [PodCreate](#PodCreate) type for input.
// On success, the ID of the newly created pod will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"name": "test"}}'
// {
//   "pod": "b05dee7bd4ccfee688099fe1588a7a898d6ddd6897de9251d4671c9b0feacb2a"
// }
// # $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"infra": true, "share": ["ipc", "net", "uts"]}}'
// {
//   "pod": "d7697449a8035f613c1a8891286502aca68fff7d5d49a85279b3bda229af3b28"
// }
// ~~~
type CreatePod_methods struct{}

func CreatePod() CreatePod_methods { return CreatePod_methods{} }

func (m CreatePod_methods) Call(c *varlink.Connection, create_in_ PodCreate) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, create_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m CreatePod_methods) Send(c *varlink.Connection, flags uint64, create_in_ PodCreate) (func() (string, uint64, error), error) {
	var in struct {
		Create PodCreate `json:"create"`
	}
	in.Create = create_in_
	receive, err := c.Send("io.podman.CreatePod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// ListPods returns a list of pods in no particular order.  They are
// returned as an array of ListPodData structs.  See also [GetPod](#GetPod).
type ListPods_methods struct{}

func ListPods() ListPods_methods { return ListPods_methods{} }

func (m ListPods_methods) Call(c *varlink.Connection) (pods_out_ []ListPodData, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	pods_out_, _, err_ = receive()
	return
}

func (m ListPods_methods) Send(c *varlink.Connection, flags uint64) (func() ([]ListPodData, uint64, error), error) {
	receive, err := c.Send("io.podman.ListPods", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (pods_out_ []ListPodData, flags uint64, err error) {
		var out struct {
			Pods []ListPodData `json:"pods"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pods_out_ = []ListPodData(out.Pods)
		return
	}, nil
}

// GetPod takes a name or ID of a pod and returns single [ListPodData](#ListPodData)
// structure.  A [PodNotFound](#PodNotFound) error will be returned if the pod cannot be found.
// See also [ListPods](ListPods).
type GetPod_methods struct{}

func GetPod() GetPod_methods { return GetPod_methods{} }

func (m GetPod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ ListPodData, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m GetPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (ListPodData, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ ListPodData, flags uint64, err error) {
		var out struct {
			Pod ListPodData `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// InspectPod takes the name or ID of an image and returns a string respresentation of data associated with the
// pod.  You must serialize the string into JSON to use it further.  A [PodNotFound](#PodNotFound) error will
// be returned if the pod cannot be found.
type InspectPod_methods struct{}

func InspectPod() InspectPod_methods { return InspectPod_methods{} }

func (m InspectPod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m InspectPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.InspectPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// StartPod starts containers in a pod.  It takes the name or ID of pod.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
// error will be returned.  Containers in a pod are started independently. If there is an error starting one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was started with no errors, the pod ID is returned.
// See also [CreatePod](#CreatePod).
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StartPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6",
// }
// ~~~
type StartPod_methods struct{}

func StartPod() StartPod_methods { return StartPod_methods{} }

func (m StartPod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m StartPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.StartPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// StopPod stops containers in a pod.  It takes the name or ID of a pod.
// If the pod cannot be found, a [PodNotFound](#PodNotFound) error will be returned instead.
// Containers in a pod are stopped independently. If there is an error stopping one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was stopped with no errors, the pod ID is returned.
// See also [KillPod](KillPod).
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StopPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
type StopPod_methods struct{}

func StopPod() StopPod_methods { return StopPod_methods{} }

func (m StopPod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m StopPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.StopPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// RestartPod will restart containers in a pod given a pod name or ID. Containers in
// the pod that are running will be stopped, then all stopped containers will be run.
// If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are restarted independently. If there is an error restarting one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was restarted with no errors, the pod ID is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RestartPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
type RestartPod_methods struct{}

func RestartPod() RestartPod_methods { return RestartPod_methods{} }

func (m RestartPod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m RestartPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.RestartPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// KillPod takes the name or ID of a pod as well as a signal to be applied to the pod.  If the pod cannot be found, a
// [PodNotFound](#PodNotFound) error is returned.
// Containers in a pod are killed independently. If there is an error killing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was killed with no errors, the pod ID is returned.
// See also [StopPod](StopPod).
type KillPod_methods struct{}

func KillPod() KillPod_methods { return KillPod_methods{} }

func (m KillPod_methods) Call(c *varlink.Connection, name_in_ string, signal_in_ int64) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, signal_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m KillPod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, signal_in_ int64) (func() (string, uint64, error), error) {
	var in struct {
		Name   string `json:"name"`
		Signal int64  `json:"signal"`
	}
	in.Name = name_in_
	in.Signal = signal_in_
	receive, err := c.Send("io.podman.KillPod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// PausePod takes the name or ID of a pod and pauses the running containers associated with it.  If the pod cannot be found,
// a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are paused independently. If there is an error pausing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was paused with no errors, the pod ID is returned.
// See also [UnpausePod](#UnpausePod).
type PausePod_methods struct{}

func PausePod() PausePod_methods { return PausePod_methods{} }

func (m PausePod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m PausePod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.PausePod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// UnpausePod takes the name or ID of a pod and unpauses the paused containers associated with it.  If the pod cannot be
// found, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are unpaused independently. If there is an error unpausing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was unpaused with no errors, the pod ID is returned.
// See also [PausePod](#PausePod).
type UnpausePod_methods struct{}

func UnpausePod() UnpausePod_methods { return UnpausePod_methods{} }

func (m UnpausePod_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m UnpausePod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.UnpausePod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// RemovePod takes the name or ID of a pod as well a boolean representing whether a running
// container in the pod can be stopped and removed.  If a pod has containers associated with it, and force is not true,
// an error will occur.
// If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are removed independently. If there is an error removing any container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was removed with no errors, the pod ID is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RemovePod '{"name": "62f4fd98cb57", "force": "true"}'
// {
//   "pod": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
// }
// ~~~
type RemovePod_methods struct{}

func RemovePod() RemovePod_methods { return RemovePod_methods{} }

func (m RemovePod_methods) Call(c *varlink.Connection, name_in_ string, force_in_ bool) (pod_out_ string, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_, force_in_)
	if err_ != nil {
		return
	}
	pod_out_, _, err_ = receive()
	return
}

func (m RemovePod_methods) Send(c *varlink.Connection, flags uint64, name_in_ string, force_in_ bool) (func() (string, uint64, error), error) {
	var in struct {
		Name  string `json:"name"`
		Force bool   `json:"force"`
	}
	in.Name = name_in_
	in.Force = force_in_
	receive, err := c.Send("io.podman.RemovePod", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, flags uint64, err error) {
		var out struct {
			Pod string `json:"pod"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		return
	}, nil
}

// This method has not be implemented yet.
type WaitPod_methods struct{}

func WaitPod() WaitPod_methods { return WaitPod_methods{} }

func (m WaitPod_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m WaitPod_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.WaitPod", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// This method has not been implemented yet.
type TopPod_methods struct{}

func TopPod() TopPod_methods { return TopPod_methods{} }

func (m TopPod_methods) Call(c *varlink.Connection) (notimplemented_out_ NotImplemented, err_ error) {
	receive, err_ := m.Send(c, 0)
	if err_ != nil {
		return
	}
	notimplemented_out_, _, err_ = receive()
	return
}

func (m TopPod_methods) Send(c *varlink.Connection, flags uint64) (func() (NotImplemented, uint64, error), error) {
	receive, err := c.Send("io.podman.TopPod", nil, flags)
	if err != nil {
		return nil, err
	}
	return func() (notimplemented_out_ NotImplemented, flags uint64, err error) {
		var out struct {
			Notimplemented NotImplemented `json:"notimplemented"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		notimplemented_out_ = out.Notimplemented
		return
	}, nil
}

// GetPodStats takes the name or ID of a pod and returns a pod name and slice of ContainerStats structure which
// contains attributes like memory and cpu usage.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
// error will be returned.  If the pod has no running containers associated with it, a [NoContainerRunning](#NoContainerRunning)
// error will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.GetPodStats '{"name": "7f62b508b6f12b11d8fe02e"}'
// {
//   "containers": [
//     {
//       "block_input": 0,
//       "block_output": 0,
//       "cpu": 2.833470544016107524276e-08,
//       "cpu_nano": 54363072,
//       "id": "a64b51f805121fe2c5a3dc5112eb61d6ed139e3d1c99110360d08b58d48e4a93",
//       "mem_limit": 12276146176,
//       "mem_perc": 7.974359265237864966003e-03,
//       "mem_usage": 978944,
//       "name": "quirky_heisenberg",
//       "net_input": 866,
//       "net_output": 7388,
//       "pids": 1,
//       "system_nano": 20000000
//     }
//   ],
//   "pod": "7f62b508b6f12b11d8fe02e0db4de6b9e43a7d7699b33a4fc0d574f6e82b4ebd"
// }
// ~~~
type GetPodStats_methods struct{}

func GetPodStats() GetPodStats_methods { return GetPodStats_methods{} }

func (m GetPodStats_methods) Call(c *varlink.Connection, name_in_ string) (pod_out_ string, containers_out_ []ContainerStats, err_ error) {
	receive, err_ := m.Send(c, 0, name_in_)
	if err_ != nil {
		return
	}
	pod_out_, containers_out_, _, err_ = receive()
	return
}

func (m GetPodStats_methods) Send(c *varlink.Connection, flags uint64, name_in_ string) (func() (string, []ContainerStats, uint64, error), error) {
	var in struct {
		Name string `json:"name"`
	}
	in.Name = name_in_
	receive, err := c.Send("io.podman.GetPodStats", in, flags)
	if err != nil {
		return nil, err
	}
	return func() (pod_out_ string, containers_out_ []ContainerStats, flags uint64, err error) {
		var out struct {
			Pod        string           `json:"pod"`
			Containers []ContainerStats `json:"containers"`
		}
		flags, err = receive(&out)
		if err != nil {
			return
		}
		pod_out_ = out.Pod
		containers_out_ = []ContainerStats(out.Containers)
		return
	}, nil
}

// Generated service interface with all methods

type iopodmanInterface interface {
	Ping(c VarlinkCall) error
	GetVersion(c VarlinkCall) error
	GetInfo(c VarlinkCall) error
	ListContainers(c VarlinkCall) error
	GetContainer(c VarlinkCall, name_ string) error
	CreateContainer(c VarlinkCall, create_ Create) error
	InspectContainer(c VarlinkCall, name_ string) error
	ListContainerProcesses(c VarlinkCall, name_ string, opts_ []string) error
	GetContainerLogs(c VarlinkCall, name_ string) error
	ListContainerChanges(c VarlinkCall, name_ string) error
	ExportContainer(c VarlinkCall, name_ string, path_ string) error
	GetContainerStats(c VarlinkCall, name_ string) error
	ResizeContainerTty(c VarlinkCall) error
	StartContainer(c VarlinkCall, name_ string) error
	StopContainer(c VarlinkCall, name_ string, timeout_ int64) error
	RestartContainer(c VarlinkCall, name_ string, timeout_ int64) error
	KillContainer(c VarlinkCall, name_ string, signal_ int64) error
	UpdateContainer(c VarlinkCall) error
	RenameContainer(c VarlinkCall) error
	PauseContainer(c VarlinkCall, name_ string) error
	UnpauseContainer(c VarlinkCall, name_ string) error
	AttachToContainer(c VarlinkCall) error
	GetAttachSockets(c VarlinkCall, name_ string) error
	WaitContainer(c VarlinkCall, name_ string) error
	RemoveContainer(c VarlinkCall, name_ string, force_ bool) error
	DeleteStoppedContainers(c VarlinkCall) error
	ListImages(c VarlinkCall) error
	GetImage(c VarlinkCall, name_ string) error
	BuildImage(c VarlinkCall, build_ BuildInfo) error
	CreateImage(c VarlinkCall) error
	InspectImage(c VarlinkCall, name_ string) error
	HistoryImage(c VarlinkCall, name_ string) error
	PushImage(c VarlinkCall, name_ string, tag_ string, tlsverify_ bool) error
	TagImage(c VarlinkCall, name_ string, tagged_ string) error
	RemoveImage(c VarlinkCall, name_ string, force_ bool) error
	SearchImage(c VarlinkCall, name_ string, limit_ int64) error
	DeleteUnusedImages(c VarlinkCall) error
	Commit(c VarlinkCall, name_ string, image_name_ string, changes_ []string, author_ string, message_ string, pause_ bool, manifestType_ string) error
	ImportImage(c VarlinkCall, source_ string, reference_ string, message_ string, changes_ []string) error
	ExportImage(c VarlinkCall, name_ string, destination_ string, compress_ bool, tags_ []string) error
	PullImage(c VarlinkCall, name_ string) error
	CreatePod(c VarlinkCall, create_ PodCreate) error
	ListPods(c VarlinkCall) error
	GetPod(c VarlinkCall, name_ string) error
	InspectPod(c VarlinkCall, name_ string) error
	StartPod(c VarlinkCall, name_ string) error
	StopPod(c VarlinkCall, name_ string) error
	RestartPod(c VarlinkCall, name_ string) error
	KillPod(c VarlinkCall, name_ string, signal_ int64) error
	PausePod(c VarlinkCall, name_ string) error
	UnpausePod(c VarlinkCall, name_ string) error
	RemovePod(c VarlinkCall, name_ string, force_ bool) error
	WaitPod(c VarlinkCall) error
	TopPod(c VarlinkCall) error
	GetPodStats(c VarlinkCall, name_ string) error
}

// Generated service object with all methods

type VarlinkCall struct{ varlink.Call }

// Generated reply methods for all varlink errors

// ImageNotFound means the image could not be found by the provided name or ID in local storage.
func (c *VarlinkCall) ReplyImageNotFound(name_ string) error {
	var out struct {
		Name string `json:"name"`
	}
	out.Name = name_
	return c.ReplyError("io.podman.ImageNotFound", &out)
}

// ContainerNotFound means the container could not be found by the provided name or ID in local storage.
func (c *VarlinkCall) ReplyContainerNotFound(name_ string) error {
	var out struct {
		Name string `json:"name"`
	}
	out.Name = name_
	return c.ReplyError("io.podman.ContainerNotFound", &out)
}

// NoContainerRunning means none of the containers requested are running in a command that requires a running container.
func (c *VarlinkCall) ReplyNoContainerRunning() error {
	return c.ReplyError("io.podman.NoContainerRunning", nil)
}

// PodNotFound means the pod could not be found by the provided name or ID in local storage.
func (c *VarlinkCall) ReplyPodNotFound(name_ string) error {
	var out struct {
		Name string `json:"name"`
	}
	out.Name = name_
	return c.ReplyError("io.podman.PodNotFound", &out)
}

// PodContainerError means a container associated with a pod failed to preform an operation. It contains
// a container ID of the container that failed.
func (c *VarlinkCall) ReplyPodContainerError(podname_ string, errors_ []PodContainerErrorData) error {
	var out struct {
		Podname string                  `json:"podname"`
		Errors  []PodContainerErrorData `json:"errors"`
	}
	out.Podname = podname_
	out.Errors = []PodContainerErrorData(errors_)
	return c.ReplyError("io.podman.PodContainerError", &out)
}

// NoContainersInPod means a pod has no containers on which to perform the operation. It contains
// the pod ID.
func (c *VarlinkCall) ReplyNoContainersInPod(name_ string) error {
	var out struct {
		Name string `json:"name"`
	}
	out.Name = name_
	return c.ReplyError("io.podman.NoContainersInPod", &out)
}

// ErrorOccurred is a generic error for an error that occurs during the execution.  The actual error message
// is includes as part of the error's text.
func (c *VarlinkCall) ReplyErrorOccurred(reason_ string) error {
	var out struct {
		Reason string `json:"reason"`
	}
	out.Reason = reason_
	return c.ReplyError("io.podman.ErrorOccurred", &out)
}

// RuntimeErrors generally means a runtime could not be found or gotten.
func (c *VarlinkCall) ReplyRuntimeError(reason_ string) error {
	var out struct {
		Reason string `json:"reason"`
	}
	out.Reason = reason_
	return c.ReplyError("io.podman.RuntimeError", &out)
}

// Generated reply methods for all varlink methods

func (c *VarlinkCall) ReplyPing(ping_ StringResponse) error {
	var out struct {
		Ping StringResponse `json:"ping"`
	}
	out.Ping = ping_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetVersion(version_ Version) error {
	var out struct {
		Version Version `json:"version"`
	}
	out.Version = version_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetInfo(info_ PodmanInfo) error {
	var out struct {
		Info PodmanInfo `json:"info"`
	}
	out.Info = info_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyListContainers(containers_ []ListContainerData) error {
	var out struct {
		Containers []ListContainerData `json:"containers"`
	}
	out.Containers = []ListContainerData(containers_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetContainer(container_ ListContainerData) error {
	var out struct {
		Container ListContainerData `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyCreateContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyInspectContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyListContainerProcesses(container_ []string) error {
	var out struct {
		Container []string `json:"container"`
	}
	out.Container = []string(container_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetContainerLogs(container_ []string) error {
	var out struct {
		Container []string `json:"container"`
	}
	out.Container = []string(container_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyListContainerChanges(container_ ContainerChanges) error {
	var out struct {
		Container ContainerChanges `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyExportContainer(tarfile_ string) error {
	var out struct {
		Tarfile string `json:"tarfile"`
	}
	out.Tarfile = tarfile_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetContainerStats(container_ ContainerStats) error {
	var out struct {
		Container ContainerStats `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyResizeContainerTty(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyStartContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyStopContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRestartContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyKillContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyUpdateContainer(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRenameContainer(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyPauseContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyUnpauseContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyAttachToContainer(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetAttachSockets(sockets_ Sockets) error {
	var out struct {
		Sockets Sockets `json:"sockets"`
	}
	out.Sockets = sockets_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyWaitContainer(exitcode_ int64) error {
	var out struct {
		Exitcode int64 `json:"exitcode"`
	}
	out.Exitcode = exitcode_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRemoveContainer(container_ string) error {
	var out struct {
		Container string `json:"container"`
	}
	out.Container = container_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyDeleteStoppedContainers(containers_ []string) error {
	var out struct {
		Containers []string `json:"containers"`
	}
	out.Containers = []string(containers_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyListImages(images_ []ImageInList) error {
	var out struct {
		Images []ImageInList `json:"images"`
	}
	out.Images = []ImageInList(images_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetImage(image_ ImageInList) error {
	var out struct {
		Image ImageInList `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyBuildImage(image_ BuildResponse) error {
	var out struct {
		Image BuildResponse `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyCreateImage(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyInspectImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyHistoryImage(history_ []ImageHistory) error {
	var out struct {
		History []ImageHistory `json:"history"`
	}
	out.History = []ImageHistory(history_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyPushImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyTagImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRemoveImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplySearchImage(images_ []ImageSearch) error {
	var out struct {
		Images []ImageSearch `json:"images"`
	}
	out.Images = []ImageSearch(images_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyDeleteUnusedImages(images_ []string) error {
	var out struct {
		Images []string `json:"images"`
	}
	out.Images = []string(images_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyCommit(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyImportImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyExportImage(image_ string) error {
	var out struct {
		Image string `json:"image"`
	}
	out.Image = image_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyPullImage(id_ string) error {
	var out struct {
		Id string `json:"id"`
	}
	out.Id = id_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyCreatePod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyListPods(pods_ []ListPodData) error {
	var out struct {
		Pods []ListPodData `json:"pods"`
	}
	out.Pods = []ListPodData(pods_)
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetPod(pod_ ListPodData) error {
	var out struct {
		Pod ListPodData `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyInspectPod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyStartPod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyStopPod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRestartPod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyKillPod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyPausePod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyUnpausePod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyRemovePod(pod_ string) error {
	var out struct {
		Pod string `json:"pod"`
	}
	out.Pod = pod_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyWaitPod(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyTopPod(notimplemented_ NotImplemented) error {
	var out struct {
		Notimplemented NotImplemented `json:"notimplemented"`
	}
	out.Notimplemented = notimplemented_
	return c.Reply(&out)
}

func (c *VarlinkCall) ReplyGetPodStats(pod_ string, containers_ []ContainerStats) error {
	var out struct {
		Pod        string           `json:"pod"`
		Containers []ContainerStats `json:"containers"`
	}
	out.Pod = pod_
	out.Containers = []ContainerStats(containers_)
	return c.Reply(&out)
}

// Generated dummy implementations for all varlink methods

// Ping provides a response for developers to ensure their varlink setup is working.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.Ping
// {
//   "ping": {
//     "message": "OK"
//   }
// }
// ~~~
func (s *VarlinkInterface) Ping(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.Ping")
}

// GetVersion returns a Version structure describing the libpod setup on their
// system.
func (s *VarlinkInterface) GetVersion(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.GetVersion")
}

// GetInfo returns a [PodmanInfo](#PodmanInfo) struct that describes podman and its host such as storage stats,
// build information of Podman, and system-wide registries.
func (s *VarlinkInterface) GetInfo(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.GetInfo")
}

// ListContainers returns a list of containers in no particular order.  There are
// returned as an array of ListContainerData structs.  See also [GetContainer](#GetContainer).
func (s *VarlinkInterface) ListContainers(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.ListContainers")
}

// GetContainer takes a name or ID of a container and returns single ListContainerData
// structure.  A [ContainerNotFound](#ContainerNotFound) error will be returned if the container cannot be found.
// See also [ListContainers](ListContainers) and [InspectContainer](#InspectContainer).
func (s *VarlinkInterface) GetContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetContainer")
}

// CreateContainer creates a new container from an image.  It uses a [Create](#Create) type for input. The minimum
// input required for CreateContainer is an image name.  If the image name is not found, an [ImageNotFound](#ImageNotFound)
// error will be returned.  Otherwise, the ID of the newly created container will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.CreateContainer '{"create": {"image": "alpine"}}'
// {
//   "container": "8759dafbc0a4dc3bcfb57eeb72e4331eb73c5cc09ab968e65ce45b9ad5c4b6bb"
// }
// ~~~
func (s *VarlinkInterface) CreateContainer(c VarlinkCall, create_ Create) error {
	return c.ReplyMethodNotImplemented("io.podman.CreateContainer")
}

// InspectContainer data takes a name or ID of a container returns the inspection
// data in string format.  You can then serialize the string into JSON.  A [ContainerNotFound](#ContainerNotFound)
// error will be returned if the container cannot be found. See also [InspectImage](#InspectImage).
func (s *VarlinkInterface) InspectContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.InspectContainer")
}

// ListContainerProcesses takes a name or ID of a container and returns the processes
// running inside the container as array of strings.  It will accept an array of string
// arguments that represent ps options.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.ListContainerProcesses '{"name": "135d71b9495f", "opts": []}'
// {
//   "container": [
//     "  UID   PID  PPID  C STIME TTY          TIME CMD",
//     "    0 21220 21210  0 09:05 pts/0    00:00:00 /bin/sh",
//     "    0 21232 21220  0 09:05 pts/0    00:00:00 top",
//     "    0 21284 21220  0 09:05 pts/0    00:00:00 vi /etc/hosts"
//   ]
// }
// ~~~
func (s *VarlinkInterface) ListContainerProcesses(c VarlinkCall, name_ string, opts_ []string) error {
	return c.ReplyMethodNotImplemented("io.podman.ListContainerProcesses")
}

// GetContainerLogs takes a name or ID of a container and returns the logs of that container.
// If the container cannot be found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// The container logs are returned as an array of strings.  GetContainerLogs will honor the streaming
// capability of varlink if the client invokes it.
func (s *VarlinkInterface) GetContainerLogs(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetContainerLogs")
}

// ListContainerChanges takes a name or ID of a container and returns changes between the container and
// its base image. It returns a struct of changed, deleted, and added path names.
func (s *VarlinkInterface) ListContainerChanges(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.ListContainerChanges")
}

// ExportContainer creates an image from a container.  It takes the name or ID of a container and a
// path representing the target tarfile.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.
// The return value is the written tarfile.
func (s *VarlinkInterface) ExportContainer(c VarlinkCall, name_ string, path_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.ExportContainer")
}

// GetContainerStats takes the name or ID of a container and returns a single ContainerStats structure which
// contains attributes like memory and cpu usage.  If the container cannot be found, a
// [ContainerNotFound](#ContainerNotFound) error will be returned. If the container is not running, a [NoContainerRunning](#NoContainerRunning)
// error will be returned
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.GetContainerStats '{"name": "c33e4164f384"}'
// {
//   "container": {
//     "block_input": 0,
//     "block_output": 0,
//     "cpu": 2.571123918839990154678e-08,
//     "cpu_nano": 49037378,
//     "id": "c33e4164f384aa9d979072a63319d66b74fd7a128be71fa68ede24f33ec6cfee",
//     "mem_limit": 33080606720,
//     "mem_perc": 2.166828456524753747370e-03,
//     "mem_usage": 716800,
//     "name": "competent_wozniak",
//     "net_input": 768,
//     "net_output": 5910,
//     "pids": 1,
//     "system_nano": 10000000
//   }
// }
// ~~~
func (s *VarlinkInterface) GetContainerStats(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetContainerStats")
}

// This method has not be implemented yet.
func (s *VarlinkInterface) ResizeContainerTty(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.ResizeContainerTty")
}

// StartContainer starts a created or stopped container. It takes the name or ID of container.  It returns
// the container ID once started.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned.  See also [CreateContainer](#CreateContainer).
func (s *VarlinkInterface) StartContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.StartContainer")
}

// StopContainer stops a container given a timeout.  It takes the name or ID of a container as well as a
// timeout value.  The timeout value the time before a forcible stop to the container is applied.  It
// returns the container ID once stopped. If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
// error will be returned instead. See also [KillContainer](KillContainer).
// #### Error
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StopContainer '{"name": "135d71b9495f", "timeout": 5}'
// {
//   "container": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
func (s *VarlinkInterface) StopContainer(c VarlinkCall, name_ string, timeout_ int64) error {
	return c.ReplyMethodNotImplemented("io.podman.StopContainer")
}

// RestartContainer will restart a running container given a container name or ID and timeout value. The timeout
// value is the time before a forcible stop is used to stop the container.  If the container cannot be found by
// name or ID, a [ContainerNotFound](#ContainerNotFound)  error will be returned; otherwise, the ID of the
// container will be returned.
func (s *VarlinkInterface) RestartContainer(c VarlinkCall, name_ string, timeout_ int64) error {
	return c.ReplyMethodNotImplemented("io.podman.RestartContainer")
}

// KillContainer takes the name or ID of a container as well as a signal to be applied to the container.  Once the
// container has been killed, the container's ID is returned.  If the container cannot be found, a
// [ContainerNotFound](#ContainerNotFound) error is returned. See also [StopContainer](StopContainer).
func (s *VarlinkInterface) KillContainer(c VarlinkCall, name_ string, signal_ int64) error {
	return c.ReplyMethodNotImplemented("io.podman.KillContainer")
}

// This method has not be implemented yet.
func (s *VarlinkInterface) UpdateContainer(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.UpdateContainer")
}

// This method has not be implemented yet.
func (s *VarlinkInterface) RenameContainer(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.RenameContainer")
}

// PauseContainer takes the name or ID of container and pauses it.  If the container cannot be found,
// a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
// See also [UnpauseContainer](#UnpauseContainer).
func (s *VarlinkInterface) PauseContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.PauseContainer")
}

// UnpauseContainer takes the name or ID of container and unpauses a paused container.  If the container cannot be
// found, a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
// See also [PauseContainer](#PauseContainer).
func (s *VarlinkInterface) UnpauseContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.UnpauseContainer")
}

// This method has not be implemented yet.
func (s *VarlinkInterface) AttachToContainer(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.AttachToContainer")
}

// GetAttachSockets takes the name or ID of an existing container.  It returns file paths for two sockets needed
// to properly communicate with a container.  The first is the actual I/O socket that the container uses.  The
// second is a "control" socket where things like resizing the TTY events are sent. If the container cannot be
// found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/io.podman/io.podman.GetAttachSockets '{"name": "b7624e775431219161"}'
// {
//   "sockets": {
//     "container_id": "b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca",
//     "control_socket": "/var/lib/containers/storage/overlay-containers/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/userdata/ctl",
//     "io_socket": "/var/run/libpod/socket/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/attach"
//   }
// }
// ~~~
func (s *VarlinkInterface) GetAttachSockets(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetAttachSockets")
}

// WaitContainer takes the name or ID of a container and waits until the container stops.  Upon stopping, the return
// code of the container is returned. If the container container cannot be found by ID or name,
// a [ContainerNotFound](#ContainerNotFound) error is returned.
func (s *VarlinkInterface) WaitContainer(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.WaitContainer")
}

// RemoveContainer takes requires the name or ID of container as well a boolean representing whether a running
// container can be stopped and removed.  Upon successful removal of the container, its ID is returned.  If the
// container cannot be found by name or ID, a [ContainerNotFound](#ContainerNotFound) error will be returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RemoveContainer '{"name": "62f4fd98cb57"}'
// {
//   "container": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
// }
// ~~~
func (s *VarlinkInterface) RemoveContainer(c VarlinkCall, name_ string, force_ bool) error {
	return c.ReplyMethodNotImplemented("io.podman.RemoveContainer")
}

// DeleteStoppedContainers will delete all containers that are not running. It will return a list the deleted
// container IDs.  See also [RemoveContainer](RemoveContainer).
func (s *VarlinkInterface) DeleteStoppedContainers(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.DeleteStoppedContainers")
}

// ListImages returns an array of ImageInList structures which provide basic information about
// an image currently in storage.  See also [InspectImage](InspectImage).
func (s *VarlinkInterface) ListImages(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.ListImages")
}

// GetImage returns a single image in an [ImageInList](#ImageInList) struct.  You must supply an image name as a string.
// If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.
func (s *VarlinkInterface) GetImage(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetImage")
}

// BuildImage takes a [BuildInfo](#BuildInfo) structure and builds an image.  At a minimum, you must provide the
// 'dockerfile' and 'tags' options in the BuildInfo structure. It will return a [BuildResponse](#BuildResponse) structure
// that contains the build logs and resulting image ID.
func (s *VarlinkInterface) BuildImage(c VarlinkCall, build_ BuildInfo) error {
	return c.ReplyMethodNotImplemented("io.podman.BuildImage")
}

// This function is not implemented yet.
func (s *VarlinkInterface) CreateImage(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.CreateImage")
}

// InspectImage takes the name or ID of an image and returns a string respresentation of data associated with the
// mage.  You must serialize the string into JSON to use it further.  An [ImageNotFound](#ImageNotFound) error will
// be returned if the image cannot be found.
func (s *VarlinkInterface) InspectImage(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.InspectImage")
}

// HistoryImage takes the name or ID of an image and returns information about its history and layers.  The returned
// history is in the form of an array of ImageHistory structures.  If the image cannot be found, an
// [ImageNotFound](#ImageNotFound) error is returned.
func (s *VarlinkInterface) HistoryImage(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.HistoryImage")
}

// PushImage takes three input arguments: the name or ID of an image, the fully-qualified destination name of the image,
// and a boolean as to whether tls-verify should be used.  It will return an [ImageNotFound](#ImageNotFound) error if
// the image cannot be found in local storage; otherwise the ID of the image will be returned on success.
func (s *VarlinkInterface) PushImage(c VarlinkCall, name_ string, tag_ string, tlsverify_ bool) error {
	return c.ReplyMethodNotImplemented("io.podman.PushImage")
}

// TagImage takes the name or ID of an image in local storage as well as the desired tag name.  If the image cannot
// be found, an [ImageNotFound](#ImageNotFound) error will be returned; otherwise, the ID of the image is returned on success.
func (s *VarlinkInterface) TagImage(c VarlinkCall, name_ string, tagged_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.TagImage")
}

// RemoveImage takes the name or ID of an image as well as a boolean that determines if containers using that image
// should be deleted.  If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.  The
// ID of the removed image is returned when complete.  See also [DeleteUnusedImages](DeleteUnusedImages).
// #### Example
// ~~~
// varlink call -m unix:/run/podman/io.podman/io.podman.RemoveImage '{"name": "registry.fedoraproject.org/fedora", "force": true}'
// {
//   "image": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
// }
// ~~~
func (s *VarlinkInterface) RemoveImage(c VarlinkCall, name_ string, force_ bool) error {
	return c.ReplyMethodNotImplemented("io.podman.RemoveImage")
}

// SearchImage takes the string of an image name and a limit of searches from each registries to be returned.  SearchImage
// will then use a glob-like match to find the image you are searching for.  The images are returned in an array of
// ImageSearch structures which contain information about the image as well as its fully-qualified name.
func (s *VarlinkInterface) SearchImage(c VarlinkCall, name_ string, limit_ int64) error {
	return c.ReplyMethodNotImplemented("io.podman.SearchImage")
}

// DeleteUnusedImages deletes any images not associated with a container.  The IDs of the deleted images are returned
// in a string array.
func (s *VarlinkInterface) DeleteUnusedImages(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.DeleteUnusedImages")
}

// Commit, creates an image from an existing container. It requires the name or
// ID of the container as well as the resulting image name.  Optionally, you can define an author and message
// to be added to the resulting image.  You can also define changes to the resulting image for the following
// attributes: _CMD, ENTRYPOINT, ENV, EXPOSE, LABEL, ONBUILD, STOPSIGNAL, USER, VOLUME, and WORKDIR_.  To pause the
// container while it is being committed, pass a _true_ bool for the pause argument.  If the container cannot
// be found by the ID or name provided, a (ContainerNotFound)[#ContainerNotFound] error will be returned; otherwise,
// the resulting image's ID will be returned as a string.
func (s *VarlinkInterface) Commit(c VarlinkCall, name_ string, image_name_ string, changes_ []string, author_ string, message_ string, pause_ bool, manifestType_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.Commit")
}

// ImportImage imports an image from a source (like tarball) into local storage.  The image can have additional
// descriptions added to it using the message and changes options. See also [ExportImage](ExportImage).
func (s *VarlinkInterface) ImportImage(c VarlinkCall, source_ string, reference_ string, message_ string, changes_ []string) error {
	return c.ReplyMethodNotImplemented("io.podman.ImportImage")
}

// ExportImage takes the name or ID of an image and exports it to a destination like a tarball.  There is also
// a booleon option to force compression.  It also takes in a string array of tags to be able to save multiple
// tags of the same image to a tarball (each tag should be of the form <image>:<tag>).  Upon completion, the ID
// of the image is returned. If the image cannot be found in local storage, an [ImageNotFound](#ImageNotFound)
// error will be returned. See also [ImportImage](ImportImage).
func (s *VarlinkInterface) ExportImage(c VarlinkCall, name_ string, destination_ string, compress_ bool, tags_ []string) error {
	return c.ReplyMethodNotImplemented("io.podman.ExportImage")
}

// PullImage pulls an image from a repository to local storage.  After the pull is successful, the ID of the image
// is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.PullImage '{"name": "registry.fedoraproject.org/fedora"}'
// {
//   "id": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
// }
// ~~~
func (s *VarlinkInterface) PullImage(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.PullImage")
}

// CreatePod creates a new empty pod.  It uses a [PodCreate](#PodCreate) type for input.
// On success, the ID of the newly created pod will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"name": "test"}}'
// {
//   "pod": "b05dee7bd4ccfee688099fe1588a7a898d6ddd6897de9251d4671c9b0feacb2a"
// }
// # $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"infra": true, "share": ["ipc", "net", "uts"]}}'
// {
//   "pod": "d7697449a8035f613c1a8891286502aca68fff7d5d49a85279b3bda229af3b28"
// }
// ~~~
func (s *VarlinkInterface) CreatePod(c VarlinkCall, create_ PodCreate) error {
	return c.ReplyMethodNotImplemented("io.podman.CreatePod")
}

// ListPods returns a list of pods in no particular order.  They are
// returned as an array of ListPodData structs.  See also [GetPod](#GetPod).
func (s *VarlinkInterface) ListPods(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.ListPods")
}

// GetPod takes a name or ID of a pod and returns single [ListPodData](#ListPodData)
// structure.  A [PodNotFound](#PodNotFound) error will be returned if the pod cannot be found.
// See also [ListPods](ListPods).
func (s *VarlinkInterface) GetPod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetPod")
}

// InspectPod takes the name or ID of an image and returns a string respresentation of data associated with the
// pod.  You must serialize the string into JSON to use it further.  A [PodNotFound](#PodNotFound) error will
// be returned if the pod cannot be found.
func (s *VarlinkInterface) InspectPod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.InspectPod")
}

// StartPod starts containers in a pod.  It takes the name or ID of pod.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
// error will be returned.  Containers in a pod are started independently. If there is an error starting one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was started with no errors, the pod ID is returned.
// See also [CreatePod](#CreatePod).
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StartPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6",
// }
// ~~~
func (s *VarlinkInterface) StartPod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.StartPod")
}

// StopPod stops containers in a pod.  It takes the name or ID of a pod.
// If the pod cannot be found, a [PodNotFound](#PodNotFound) error will be returned instead.
// Containers in a pod are stopped independently. If there is an error stopping one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was stopped with no errors, the pod ID is returned.
// See also [KillPod](KillPod).
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.StopPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
func (s *VarlinkInterface) StopPod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.StopPod")
}

// RestartPod will restart containers in a pod given a pod name or ID. Containers in
// the pod that are running will be stopped, then all stopped containers will be run.
// If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are restarted independently. If there is an error restarting one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was restarted with no errors, the pod ID is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RestartPod '{"name": "135d71b9495f"}'
// {
//   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
// }
// ~~~
func (s *VarlinkInterface) RestartPod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.RestartPod")
}

// KillPod takes the name or ID of a pod as well as a signal to be applied to the pod.  If the pod cannot be found, a
// [PodNotFound](#PodNotFound) error is returned.
// Containers in a pod are killed independently. If there is an error killing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was killed with no errors, the pod ID is returned.
// See also [StopPod](StopPod).
func (s *VarlinkInterface) KillPod(c VarlinkCall, name_ string, signal_ int64) error {
	return c.ReplyMethodNotImplemented("io.podman.KillPod")
}

// PausePod takes the name or ID of a pod and pauses the running containers associated with it.  If the pod cannot be found,
// a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are paused independently. If there is an error pausing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was paused with no errors, the pod ID is returned.
// See also [UnpausePod](#UnpausePod).
func (s *VarlinkInterface) PausePod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.PausePod")
}

// UnpausePod takes the name or ID of a pod and unpauses the paused containers associated with it.  If the pod cannot be
// found, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are unpaused independently. If there is an error unpausing one container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was unpaused with no errors, the pod ID is returned.
// See also [PausePod](#PausePod).
func (s *VarlinkInterface) UnpausePod(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.UnpausePod")
}

// RemovePod takes the name or ID of a pod as well a boolean representing whether a running
// container in the pod can be stopped and removed.  If a pod has containers associated with it, and force is not true,
// an error will occur.
// If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
// Containers in a pod are removed independently. If there is an error removing any container, the ID of those containers
// will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
// If the pod was removed with no errors, the pod ID is returned.
// #### Example
// ~~~
// $ varlink call -m unix:/run/podman/io.podman/io.podman.RemovePod '{"name": "62f4fd98cb57", "force": "true"}'
// {
//   "pod": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
// }
// ~~~
func (s *VarlinkInterface) RemovePod(c VarlinkCall, name_ string, force_ bool) error {
	return c.ReplyMethodNotImplemented("io.podman.RemovePod")
}

// This method has not be implemented yet.
func (s *VarlinkInterface) WaitPod(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.WaitPod")
}

// This method has not been implemented yet.
func (s *VarlinkInterface) TopPod(c VarlinkCall) error {
	return c.ReplyMethodNotImplemented("io.podman.TopPod")
}

// GetPodStats takes the name or ID of a pod and returns a pod name and slice of ContainerStats structure which
// contains attributes like memory and cpu usage.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
// error will be returned.  If the pod has no running containers associated with it, a [NoContainerRunning](#NoContainerRunning)
// error will be returned.
// #### Example
// ~~~
// $ varlink call unix:/run/podman/io.podman/io.podman.GetPodStats '{"name": "7f62b508b6f12b11d8fe02e"}'
// {
//   "containers": [
//     {
//       "block_input": 0,
//       "block_output": 0,
//       "cpu": 2.833470544016107524276e-08,
//       "cpu_nano": 54363072,
//       "id": "a64b51f805121fe2c5a3dc5112eb61d6ed139e3d1c99110360d08b58d48e4a93",
//       "mem_limit": 12276146176,
//       "mem_perc": 7.974359265237864966003e-03,
//       "mem_usage": 978944,
//       "name": "quirky_heisenberg",
//       "net_input": 866,
//       "net_output": 7388,
//       "pids": 1,
//       "system_nano": 20000000
//     }
//   ],
//   "pod": "7f62b508b6f12b11d8fe02e0db4de6b9e43a7d7699b33a4fc0d574f6e82b4ebd"
// }
// ~~~
func (s *VarlinkInterface) GetPodStats(c VarlinkCall, name_ string) error {
	return c.ReplyMethodNotImplemented("io.podman.GetPodStats")
}

// Generated method call dispatcher

func (s *VarlinkInterface) VarlinkDispatch(call varlink.Call, methodname string) error {
	switch methodname {
	case "Ping":
		return s.iopodmanInterface.Ping(VarlinkCall{call})

	case "GetVersion":
		return s.iopodmanInterface.GetVersion(VarlinkCall{call})

	case "GetInfo":
		return s.iopodmanInterface.GetInfo(VarlinkCall{call})

	case "ListContainers":
		return s.iopodmanInterface.ListContainers(VarlinkCall{call})

	case "GetContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetContainer(VarlinkCall{call}, in.Name)

	case "CreateContainer":
		var in struct {
			Create Create `json:"create"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.CreateContainer(VarlinkCall{call}, in.Create)

	case "InspectContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.InspectContainer(VarlinkCall{call}, in.Name)

	case "ListContainerProcesses":
		var in struct {
			Name string   `json:"name"`
			Opts []string `json:"opts"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.ListContainerProcesses(VarlinkCall{call}, in.Name, []string(in.Opts))

	case "GetContainerLogs":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetContainerLogs(VarlinkCall{call}, in.Name)

	case "ListContainerChanges":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.ListContainerChanges(VarlinkCall{call}, in.Name)

	case "ExportContainer":
		var in struct {
			Name string `json:"name"`
			Path string `json:"path"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.ExportContainer(VarlinkCall{call}, in.Name, in.Path)

	case "GetContainerStats":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetContainerStats(VarlinkCall{call}, in.Name)

	case "ResizeContainerTty":
		return s.iopodmanInterface.ResizeContainerTty(VarlinkCall{call})

	case "StartContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.StartContainer(VarlinkCall{call}, in.Name)

	case "StopContainer":
		var in struct {
			Name    string `json:"name"`
			Timeout int64  `json:"timeout"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.StopContainer(VarlinkCall{call}, in.Name, in.Timeout)

	case "RestartContainer":
		var in struct {
			Name    string `json:"name"`
			Timeout int64  `json:"timeout"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.RestartContainer(VarlinkCall{call}, in.Name, in.Timeout)

	case "KillContainer":
		var in struct {
			Name   string `json:"name"`
			Signal int64  `json:"signal"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.KillContainer(VarlinkCall{call}, in.Name, in.Signal)

	case "UpdateContainer":
		return s.iopodmanInterface.UpdateContainer(VarlinkCall{call})

	case "RenameContainer":
		return s.iopodmanInterface.RenameContainer(VarlinkCall{call})

	case "PauseContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.PauseContainer(VarlinkCall{call}, in.Name)

	case "UnpauseContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.UnpauseContainer(VarlinkCall{call}, in.Name)

	case "AttachToContainer":
		return s.iopodmanInterface.AttachToContainer(VarlinkCall{call})

	case "GetAttachSockets":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetAttachSockets(VarlinkCall{call}, in.Name)

	case "WaitContainer":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.WaitContainer(VarlinkCall{call}, in.Name)

	case "RemoveContainer":
		var in struct {
			Name  string `json:"name"`
			Force bool   `json:"force"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.RemoveContainer(VarlinkCall{call}, in.Name, in.Force)

	case "DeleteStoppedContainers":
		return s.iopodmanInterface.DeleteStoppedContainers(VarlinkCall{call})

	case "ListImages":
		return s.iopodmanInterface.ListImages(VarlinkCall{call})

	case "GetImage":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetImage(VarlinkCall{call}, in.Name)

	case "BuildImage":
		var in struct {
			Build BuildInfo `json:"build"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.BuildImage(VarlinkCall{call}, in.Build)

	case "CreateImage":
		return s.iopodmanInterface.CreateImage(VarlinkCall{call})

	case "InspectImage":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.InspectImage(VarlinkCall{call}, in.Name)

	case "HistoryImage":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.HistoryImage(VarlinkCall{call}, in.Name)

	case "PushImage":
		var in struct {
			Name      string `json:"name"`
			Tag       string `json:"tag"`
			Tlsverify bool   `json:"tlsverify"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.PushImage(VarlinkCall{call}, in.Name, in.Tag, in.Tlsverify)

	case "TagImage":
		var in struct {
			Name   string `json:"name"`
			Tagged string `json:"tagged"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.TagImage(VarlinkCall{call}, in.Name, in.Tagged)

	case "RemoveImage":
		var in struct {
			Name  string `json:"name"`
			Force bool   `json:"force"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.RemoveImage(VarlinkCall{call}, in.Name, in.Force)

	case "SearchImage":
		var in struct {
			Name  string `json:"name"`
			Limit int64  `json:"limit"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.SearchImage(VarlinkCall{call}, in.Name, in.Limit)

	case "DeleteUnusedImages":
		return s.iopodmanInterface.DeleteUnusedImages(VarlinkCall{call})

	case "Commit":
		var in struct {
			Name         string   `json:"name"`
			Image_name   string   `json:"image_name"`
			Changes      []string `json:"changes"`
			Author       string   `json:"author"`
			Message      string   `json:"message"`
			Pause        bool     `json:"pause"`
			ManifestType string   `json:"manifestType"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.Commit(VarlinkCall{call}, in.Name, in.Image_name, []string(in.Changes), in.Author, in.Message, in.Pause, in.ManifestType)

	case "ImportImage":
		var in struct {
			Source    string   `json:"source"`
			Reference string   `json:"reference"`
			Message   string   `json:"message"`
			Changes   []string `json:"changes"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.ImportImage(VarlinkCall{call}, in.Source, in.Reference, in.Message, []string(in.Changes))

	case "ExportImage":
		var in struct {
			Name        string   `json:"name"`
			Destination string   `json:"destination"`
			Compress    bool     `json:"compress"`
			Tags        []string `json:"tags"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.ExportImage(VarlinkCall{call}, in.Name, in.Destination, in.Compress, []string(in.Tags))

	case "PullImage":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.PullImage(VarlinkCall{call}, in.Name)

	case "CreatePod":
		var in struct {
			Create PodCreate `json:"create"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.CreatePod(VarlinkCall{call}, in.Create)

	case "ListPods":
		return s.iopodmanInterface.ListPods(VarlinkCall{call})

	case "GetPod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetPod(VarlinkCall{call}, in.Name)

	case "InspectPod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.InspectPod(VarlinkCall{call}, in.Name)

	case "StartPod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.StartPod(VarlinkCall{call}, in.Name)

	case "StopPod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.StopPod(VarlinkCall{call}, in.Name)

	case "RestartPod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.RestartPod(VarlinkCall{call}, in.Name)

	case "KillPod":
		var in struct {
			Name   string `json:"name"`
			Signal int64  `json:"signal"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.KillPod(VarlinkCall{call}, in.Name, in.Signal)

	case "PausePod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.PausePod(VarlinkCall{call}, in.Name)

	case "UnpausePod":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.UnpausePod(VarlinkCall{call}, in.Name)

	case "RemovePod":
		var in struct {
			Name  string `json:"name"`
			Force bool   `json:"force"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.RemovePod(VarlinkCall{call}, in.Name, in.Force)

	case "WaitPod":
		return s.iopodmanInterface.WaitPod(VarlinkCall{call})

	case "TopPod":
		return s.iopodmanInterface.TopPod(VarlinkCall{call})

	case "GetPodStats":
		var in struct {
			Name string `json:"name"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter("parameters")
		}
		return s.iopodmanInterface.GetPodStats(VarlinkCall{call}, in.Name)

	default:
		return call.ReplyMethodNotFound(methodname)
	}
}

// Generated varlink interface name

func (s *VarlinkInterface) VarlinkGetName() string {
	return `io.podman`
}

// Generated varlink interface description

func (s *VarlinkInterface) VarlinkGetDescription() string {
	return `# Podman Service Interface and API description.  The master version of this document can be found
# in the [API.md](https://github.com/containers/libpod/blob/master/API.md) file in the upstream libpod repository.
interface io.podman


# Version is the structure returned by GetVersion
type Version (
  version: string,
  go_version: string,
  git_commit: string,
  built: int,
  os_arch: string
)

type NotImplemented (
    comment: string
)

type StringResponse (
    message: string
)
# ContainerChanges describes the return struct for ListContainerChanges
type ContainerChanges (
   changed: []string,
   added: []string,
   deleted: []string
)

# ImageInList describes the structure that is returned in
# ListImages.
type ImageInList (
  id: string,
  parentId: string,
  repoTags: []string,
  repoDigests: []string,
  created: string,
  size: int,
  virtualSize: int,
  containers: int,
  labels: [string]string
)

# ImageHistory describes the returned structure from ImageHistory.
type ImageHistory (
    id: string,
    created: string,
    createdBy: string,
    tags: []string,
    size: int,
    comment: string
)

# ImageSearch is the returned structure for SearchImage.  It is returned
# in array form.
type ImageSearch (
    description: string,
    is_official: bool,
    is_automated: bool,
    name: string,
    star_count: int
)

# ListContainer is the returned struct for an individual container
type ListContainerData (
    id: string,
    image: string,
    imageid: string,
    command: []string,
    createdat: string,
    runningfor: string,
    status: string,
    ports: []ContainerPortMappings,
    rootfssize: int,
    rwsize: int,
    names: string,
    labels: [string]string,
    mounts: []ContainerMount,
    containerrunning: bool,
    namespaces: ContainerNameSpace
)

# ContainerStats is the return struct for the stats of a container
type ContainerStats (
    id: string,
    name: string,
    cpu: float,
    cpu_nano: int,
    system_nano: int,
    mem_usage: int,
    mem_limit: int,
    mem_perc: float,
    net_input: int,
    net_output: int,
    block_output: int,
    block_input: int,
    pids: int
)

# ContainerMount describes the struct for mounts in a container
type ContainerMount (
    destination: string,
    type: string,
    source: string,
    options: []string
)

# ContainerPortMappings describes the struct for portmappings in an existing container
type ContainerPortMappings (
    host_port: string,
    host_ip: string,
    protocol: string,
    container_port: string
)

# ContainerNamespace describes the namespace structure for an existing container
type ContainerNameSpace (
    user: string,
    uts: string,
    pidns: string,
    pid: string,
    cgroup: string,
    net: string,
    mnt: string,
    ipc: string
)

# InfoDistribution describes the the host's distribution
type InfoDistribution (
    distribution: string,
    version: string
)

# InfoHost describes the host stats portion of PodmanInfo
type InfoHost (
    buildah_version: string,
    distribution: InfoDistribution,
    mem_free: int,
    mem_total: int,
    swap_free: int,
    swap_total: int,
    arch: string,
    cpus: int,
    hostname: string,
    kernel: string,
    os: string,
    uptime: string
)

# InfoGraphStatus describes the detailed status of the storage driver
type InfoGraphStatus (
    backing_filesystem: string,
    native_overlay_diff: string,
    supports_d_type: string
)

# InfoStore describes the host's storage informatoin
type InfoStore (
    containers: int,
    images: int,
    graph_driver_name: string,
    graph_driver_options: string,
    graph_root: string,
    graph_status: InfoGraphStatus,
    run_root: string
)

# InfoPodman provides details on the podman binary
type InfoPodmanBinary (
    compiler: string,
    go_version: string,
    podman_version: string,
    git_commit: string
)

# PodmanInfo describes the Podman host and build
type PodmanInfo (
    host: InfoHost,
    registries: []string,
    insecure_registries: []string,
    store: InfoStore,
    podman: InfoPodmanBinary
)

# Sockets describes sockets location for a container
type Sockets(
    container_id: string,
    io_socket: string,
    control_socket: string
)

# Create is an input structure for creating containers. It closely resembles the
# CreateConfig structure in libpod/pkg/spec.
type Create (
    args: []string,
    cap_add: []string,
    cap_drop: []string,
    conmon_pidfile: string,
    cgroup_parent: string,
    command: []string,
    detach: bool,
    devices: []string,
    dns_opt: []string,
    dns_search: []string,
    dns_servers: []string,
    entrypoint: []string,
    env:  [string]string,
    exposed_ports: []string,
    gidmap: []string,
    group_add: []string,
    host_add: []string,
    hostname: string,
    image: string,
    image_id: string,
    builtin_imgvolumes: []string,
    id_mappings: IDMappingOptions,
    image_volume_type: string,
    interactive: bool,
    ipc_mode: string,
    labels: [string]string,
    log_driver: string,
    log_driver_opt: []string,
    name: string,
    net_mode: string,
    network: string,
    pid_mode: string,
    pod: string,
    privileged: bool,
    publish: []string,
    publish_all: bool,
    quiet: bool,
    readonly_rootfs: bool,
    resources: CreateResourceConfig,
    rm: bool,
    shm_dir: string,
    stop_signal: int,
    stop_timeout: int,
    subuidmap: string,
    subgidmap: string,
    subuidname: string,
    subgidname: string,
    sys_ctl: [string]string,
    tmpfs: []string,
    tty: bool,
    uidmap: []string,
    userns_mode: string,
    user: string,
    uts_mode: string,
    volumes: []string,
    work_dir: string,
    mount_label: string,
    process_label: string,
    no_new_privs: bool,
    apparmor_profile: string,
    seccomp_profile_path: string,
    security_opts: []string
)

# CreateResourceConfig is an input structure used to describe host attributes during
# container creation.  It is only valid inside a [Create](#Create) type.
type CreateResourceConfig (
    blkio_weight: int,
    blkio_weight_device: []string,
    cpu_period: int,
    cpu_quota: int,
    cpu_rt_period: int,
    cpu_rt_runtime: int,
    cpu_shares: int,
    cpus: float,
    cpuset_cpus: string,
    cpuset_mems: string,
    device_read_bps: []string,
    device_read_iops: []string,
    device_write_bps: []string,
    device_write_iops: []string,
    disable_oomkiller: bool,
    kernel_memory: int,
    memory: int,
    memory_reservation: int,
    memory_swap: int,
    memory_swappiness: int,
    oom_score_adj: int,
    pids_limit: int,
    shm_size: int,
    ulimit: []string
)

# IDMappingOptions is an input structure used to described ids during container creation.
type IDMappingOptions (
    host_uid_mapping: bool,
    host_gid_mapping: bool,
    uid_map: IDMap,
    gid_map: IDMap
)

# IDMap is used to describe user name spaces during container creation
type IDMap (
    container_id: int,
    host_id: int,
    size: int
)

# BuildInfo is used to describe user input for building images
type BuildInfo (
    # paths to one or more dockerfiles
    dockerfile: []string,
    tags: []string,
    add_hosts: []string,
    cgroup_parent: string,
    cpu_period: int,
    cpu_quota: int,
    cpu_shares: int,
    cpuset_cpus: string,
    cpuset_mems: string,
    memory: string,
    memory_swap: string,
    security_opts: []string,
    shm_size: string,
    ulimit: []string,
    volume: []string,
    squash: bool,
    pull: bool,
    pull_always: bool,
    force_rm: bool,
    rm: bool,
    label: []string,
    annotations: []string,
    build_args: [string]string,
    image_format: string
)

# BuildResponse is used to describe the responses for building images
type BuildResponse (
    logs: []string,
    id: string
)

# ListPodContainerInfo is a returned struct for describing containers
# in a pod.
type ListPodContainerInfo (
    name: string,
    id: string,
    status: string
)

# PodCreate is an input structure for creating pods.
# It emulates options to podman pod create, however
# changing pause image name and pause container
# is not currently supported
type PodCreate (
    name: string,
    cgroupParent: string,
    labels: [string]string,
    share: []string,
    infra: bool
)

# ListPodData is the returned struct for an individual pod
type ListPodData (
    id: string,
    name: string,
    createdat: string,
    cgroup: string,
    status: string,
    labels: [string]string,
    numberofcontainers: string,
    containersinfo: []ListPodContainerInfo
)

type PodContainerErrorData (
    containerid: string,
    reason: string
)

# Ping provides a response for developers to ensure their varlink setup is working.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.Ping
# {
#   "ping": {
#     "message": "OK"
#   }
# }
# ~~~
method Ping() -> (ping: StringResponse)

# GetVersion returns a Version structure describing the libpod setup on their
# system.
method GetVersion() -> (version: Version)

# GetInfo returns a [PodmanInfo](#PodmanInfo) struct that describes podman and its host such as storage stats,
# build information of Podman, and system-wide registries.
method GetInfo() -> (info: PodmanInfo)

# ListContainers returns a list of containers in no particular order.  There are
# returned as an array of ListContainerData structs.  See also [GetContainer](#GetContainer).
method ListContainers() -> (containers: []ListContainerData)

# GetContainer takes a name or ID of a container and returns single ListContainerData
# structure.  A [ContainerNotFound](#ContainerNotFound) error will be returned if the container cannot be found.
# See also [ListContainers](ListContainers) and [InspectContainer](#InspectContainer).
method GetContainer(name: string) -> (container: ListContainerData)

# CreateContainer creates a new container from an image.  It uses a [Create](#Create) type for input. The minimum
# input required for CreateContainer is an image name.  If the image name is not found, an [ImageNotFound](#ImageNotFound)
# error will be returned.  Otherwise, the ID of the newly created container will be returned.
# #### Example
# ~~~
# $ varlink call unix:/run/podman/io.podman/io.podman.CreateContainer '{"create": {"image": "alpine"}}'
# {
#   "container": "8759dafbc0a4dc3bcfb57eeb72e4331eb73c5cc09ab968e65ce45b9ad5c4b6bb"
# }
# ~~~
method CreateContainer(create: Create) -> (container: string)

# InspectContainer data takes a name or ID of a container returns the inspection
# data in string format.  You can then serialize the string into JSON.  A [ContainerNotFound](#ContainerNotFound)
# error will be returned if the container cannot be found. See also [InspectImage](#InspectImage).
method InspectContainer(name: string) -> (container: string)

# ListContainerProcesses takes a name or ID of a container and returns the processes
# running inside the container as array of strings.  It will accept an array of string
# arguments that represent ps options.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
# error will be returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.ListContainerProcesses '{"name": "135d71b9495f", "opts": []}'
# {
#   "container": [
#     "  UID   PID  PPID  C STIME TTY          TIME CMD",
#     "    0 21220 21210  0 09:05 pts/0    00:00:00 /bin/sh",
#     "    0 21232 21220  0 09:05 pts/0    00:00:00 top",
#     "    0 21284 21220  0 09:05 pts/0    00:00:00 vi /etc/hosts"
#   ]
# }
# ~~~
method ListContainerProcesses(name: string, opts: []string) -> (container: []string)

# GetContainerLogs takes a name or ID of a container and returns the logs of that container.
# If the container cannot be found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
# The container logs are returned as an array of strings.  GetContainerLogs will honor the streaming
# capability of varlink if the client invokes it.
method GetContainerLogs(name: string) -> (container: []string)

# ListContainerChanges takes a name or ID of a container and returns changes between the container and
# its base image. It returns a struct of changed, deleted, and added path names.
method ListContainerChanges(name: string) -> (container: ContainerChanges)

# ExportContainer creates an image from a container.  It takes the name or ID of a container and a
# path representing the target tarfile.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
# error will be returned.
# The return value is the written tarfile.
method ExportContainer(name: string, path: string) -> (tarfile: string)

# GetContainerStats takes the name or ID of a container and returns a single ContainerStats structure which
# contains attributes like memory and cpu usage.  If the container cannot be found, a
# [ContainerNotFound](#ContainerNotFound) error will be returned. If the container is not running, a [NoContainerRunning](#NoContainerRunning)
# error will be returned
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.GetContainerStats '{"name": "c33e4164f384"}'
# {
#   "container": {
#     "block_input": 0,
#     "block_output": 0,
#     "cpu": 2.571123918839990154678e-08,
#     "cpu_nano": 49037378,
#     "id": "c33e4164f384aa9d979072a63319d66b74fd7a128be71fa68ede24f33ec6cfee",
#     "mem_limit": 33080606720,
#     "mem_perc": 2.166828456524753747370e-03,
#     "mem_usage": 716800,
#     "name": "competent_wozniak",
#     "net_input": 768,
#     "net_output": 5910,
#     "pids": 1,
#     "system_nano": 10000000
#   }
# }
# ~~~
method GetContainerStats(name: string) -> (container: ContainerStats)

# This method has not be implemented yet.
method ResizeContainerTty() -> (notimplemented: NotImplemented)

# StartContainer starts a created or stopped container. It takes the name or ID of container.  It returns
# the container ID once started.  If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
# error will be returned.  See also [CreateContainer](#CreateContainer).
method StartContainer(name: string) -> (container: string)

# StopContainer stops a container given a timeout.  It takes the name or ID of a container as well as a
# timeout value.  The timeout value the time before a forcible stop to the container is applied.  It
# returns the container ID once stopped. If the container cannot be found, a [ContainerNotFound](#ContainerNotFound)
# error will be returned instead. See also [KillContainer](KillContainer).
# #### Error
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.StopContainer '{"name": "135d71b9495f", "timeout": 5}'
# {
#   "container": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
# }
# ~~~
method StopContainer(name: string, timeout: int) -> (container: string)

# RestartContainer will restart a running container given a container name or ID and timeout value. The timeout
# value is the time before a forcible stop is used to stop the container.  If the container cannot be found by
# name or ID, a [ContainerNotFound](#ContainerNotFound)  error will be returned; otherwise, the ID of the
# container will be returned.
method RestartContainer(name: string, timeout: int) -> (container: string)

# KillContainer takes the name or ID of a container as well as a signal to be applied to the container.  Once the
# container has been killed, the container's ID is returned.  If the container cannot be found, a
# [ContainerNotFound](#ContainerNotFound) error is returned. See also [StopContainer](StopContainer).
method KillContainer(name: string, signal: int) -> (container: string)

# This method has not be implemented yet.
method UpdateContainer() -> (notimplemented: NotImplemented)

# This method has not be implemented yet.
method RenameContainer() -> (notimplemented: NotImplemented)

# PauseContainer takes the name or ID of container and pauses it.  If the container cannot be found,
# a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
# See also [UnpauseContainer](#UnpauseContainer).
method PauseContainer(name: string) -> (container: string)

# UnpauseContainer takes the name or ID of container and unpauses a paused container.  If the container cannot be
# found, a [ContainerNotFound](#ContainerNotFound) error will be returned; otherwise the ID of the container is returned.
# See also [PauseContainer](#PauseContainer).
method UnpauseContainer(name: string) -> (container: string)

# This method has not be implemented yet.
method AttachToContainer() -> (notimplemented: NotImplemented)

# GetAttachSockets takes the name or ID of an existing container.  It returns file paths for two sockets needed
# to properly communicate with a container.  The first is the actual I/O socket that the container uses.  The
# second is a "control" socket where things like resizing the TTY events are sent. If the container cannot be
# found, a [ContainerNotFound](#ContainerNotFound) error will be returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/io.podman/io.podman.GetAttachSockets '{"name": "b7624e775431219161"}'
# {
#   "sockets": {
#     "container_id": "b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca",
#     "control_socket": "/var/lib/containers/storage/overlay-containers/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/userdata/ctl",
#     "io_socket": "/var/run/libpod/socket/b7624e7754312191613245ce1a46844abee60025818fe3c3f3203435623a1eca/attach"
#   }
# }
# ~~~
method GetAttachSockets(name: string) -> (sockets: Sockets)

# WaitContainer takes the name or ID of a container and waits until the container stops.  Upon stopping, the return
# code of the container is returned. If the container container cannot be found by ID or name,
# a [ContainerNotFound](#ContainerNotFound) error is returned.
method WaitContainer(name: string) -> (exitcode: int)

# RemoveContainer takes requires the name or ID of container as well a boolean representing whether a running
# container can be stopped and removed.  Upon successful removal of the container, its ID is returned.  If the
# container cannot be found by name or ID, a [ContainerNotFound](#ContainerNotFound) error will be returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.RemoveContainer '{"name": "62f4fd98cb57"}'
# {
#   "container": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
# }
# ~~~
method RemoveContainer(name: string, force: bool) -> (container: string)

# DeleteStoppedContainers will delete all containers that are not running. It will return a list the deleted
# container IDs.  See also [RemoveContainer](RemoveContainer).
method DeleteStoppedContainers() -> (containers: []string)

# ListImages returns an array of ImageInList structures which provide basic information about
# an image currently in storage.  See also [InspectImage](InspectImage).
method ListImages() -> (images: []ImageInList)

# GetImage returns a single image in an [ImageInList](#ImageInList) struct.  You must supply an image name as a string.
# If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.
method GetImage(name: string) -> (image: ImageInList)

# BuildImage takes a [BuildInfo](#BuildInfo) structure and builds an image.  At a minimum, you must provide the
# 'dockerfile' and 'tags' options in the BuildInfo structure. It will return a [BuildResponse](#BuildResponse) structure
# that contains the build logs and resulting image ID.
method BuildImage(build: BuildInfo) -> (image: BuildResponse)

# This function is not implemented yet.
method CreateImage() -> (notimplemented: NotImplemented)

# InspectImage takes the name or ID of an image and returns a string respresentation of data associated with the
#image.  You must serialize the string into JSON to use it further.  An [ImageNotFound](#ImageNotFound) error will
# be returned if the image cannot be found.
method InspectImage(name: string) -> (image: string)

# HistoryImage takes the name or ID of an image and returns information about its history and layers.  The returned
# history is in the form of an array of ImageHistory structures.  If the image cannot be found, an
# [ImageNotFound](#ImageNotFound) error is returned.
method HistoryImage(name: string) -> (history: []ImageHistory)

# PushImage takes three input arguments: the name or ID of an image, the fully-qualified destination name of the image,
# and a boolean as to whether tls-verify should be used.  It will return an [ImageNotFound](#ImageNotFound) error if
# the image cannot be found in local storage; otherwise the ID of the image will be returned on success.
method PushImage(name: string, tag: string, tlsverify: bool) -> (image: string)

# TagImage takes the name or ID of an image in local storage as well as the desired tag name.  If the image cannot
# be found, an [ImageNotFound](#ImageNotFound) error will be returned; otherwise, the ID of the image is returned on success.
method TagImage(name: string, tagged: string) -> (image: string)

# RemoveImage takes the name or ID of an image as well as a boolean that determines if containers using that image
# should be deleted.  If the image cannot be found, an [ImageNotFound](#ImageNotFound) error will be returned.  The
# ID of the removed image is returned when complete.  See also [DeleteUnusedImages](DeleteUnusedImages).
# #### Example
# ~~~
# varlink call -m unix:/run/podman/io.podman/io.podman.RemoveImage '{"name": "registry.fedoraproject.org/fedora", "force": true}'
# {
#   "image": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
# }
# ~~~
method RemoveImage(name: string, force: bool) -> (image: string)

# SearchImage takes the string of an image name and a limit of searches from each registries to be returned.  SearchImage
# will then use a glob-like match to find the image you are searching for.  The images are returned in an array of
# ImageSearch structures which contain information about the image as well as its fully-qualified name.
method SearchImage(name: string, limit: int) -> (images: []ImageSearch)

# DeleteUnusedImages deletes any images not associated with a container.  The IDs of the deleted images are returned
# in a string array.
method DeleteUnusedImages() -> (images: []string)

# Commit, creates an image from an existing container. It requires the name or
# ID of the container as well as the resulting image name.  Optionally, you can define an author and message
# to be added to the resulting image.  You can also define changes to the resulting image for the following
# attributes: _CMD, ENTRYPOINT, ENV, EXPOSE, LABEL, ONBUILD, STOPSIGNAL, USER, VOLUME, and WORKDIR_.  To pause the
# container while it is being committed, pass a _true_ bool for the pause argument.  If the container cannot
# be found by the ID or name provided, a (ContainerNotFound)[#ContainerNotFound] error will be returned; otherwise,
# the resulting image's ID will be returned as a string.
method Commit(name: string, image_name: string, changes: []string, author: string, message: string, pause: bool, manifestType: string) -> (image: string)

# ImportImage imports an image from a source (like tarball) into local storage.  The image can have additional
# descriptions added to it using the message and changes options. See also [ExportImage](ExportImage).
method ImportImage(source: string, reference: string, message: string, changes: []string) -> (image: string)

# ExportImage takes the name or ID of an image and exports it to a destination like a tarball.  There is also
# a booleon option to force compression.  It also takes in a string array of tags to be able to save multiple
# tags of the same image to a tarball (each tag should be of the form <image>:<tag>).  Upon completion, the ID
# of the image is returned. If the image cannot be found in local storage, an [ImageNotFound](#ImageNotFound)
# error will be returned. See also [ImportImage](ImportImage).
method ExportImage(name: string, destination: string, compress: bool, tags: []string) -> (image: string)

# PullImage pulls an image from a repository to local storage.  After the pull is successful, the ID of the image
# is returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.PullImage '{"name": "registry.fedoraproject.org/fedora"}'
# {
#   "id": "426866d6fa419873f97e5cbd320eeb22778244c1dfffa01c944db3114f55772e"
# }
# ~~~
method PullImage(name: string) -> (id: string)

# CreatePod creates a new empty pod.  It uses a [PodCreate](#PodCreate) type for input.
# On success, the ID of the newly created pod will be returned.
# #### Example
# ~~~
# $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"name": "test"}}'
# {
#   "pod": "b05dee7bd4ccfee688099fe1588a7a898d6ddd6897de9251d4671c9b0feacb2a"
# }
#
# $ varlink call unix:/run/podman/io.podman/io.podman.CreatePod '{"create": {"infra": true, "share": ["ipc", "net", "uts"]}}'
# {
#   "pod": "d7697449a8035f613c1a8891286502aca68fff7d5d49a85279b3bda229af3b28"
# }
# ~~~
method CreatePod(create: PodCreate) -> (pod: string)

# ListPods returns a list of pods in no particular order.  They are
# returned as an array of ListPodData structs.  See also [GetPod](#GetPod).
method ListPods() -> (pods: []ListPodData)

# GetPod takes a name or ID of a pod and returns single [ListPodData](#ListPodData)
# structure.  A [PodNotFound](#PodNotFound) error will be returned if the pod cannot be found.
# See also [ListPods](ListPods).
method GetPod(name: string) -> (pod: ListPodData)

# InspectPod takes the name or ID of an image and returns a string respresentation of data associated with the
# pod.  You must serialize the string into JSON to use it further.  A [PodNotFound](#PodNotFound) error will
# be returned if the pod cannot be found.
method InspectPod(name: string) -> (pod: string)

# StartPod starts containers in a pod.  It takes the name or ID of pod.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
# error will be returned.  Containers in a pod are started independently. If there is an error starting one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was started with no errors, the pod ID is returned.
# See also [CreatePod](#CreatePod).
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.StartPod '{"name": "135d71b9495f"}'
# {
#   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6",
# }
# ~~~
method StartPod(name: string) -> (pod: string)

# StopPod stops containers in a pod.  It takes the name or ID of a pod.
# If the pod cannot be found, a [PodNotFound](#PodNotFound) error will be returned instead.
# Containers in a pod are stopped independently. If there is an error stopping one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was stopped with no errors, the pod ID is returned.
# See also [KillPod](KillPod).
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.StopPod '{"name": "135d71b9495f"}'
# {
#   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
# }
# ~~~
method StopPod(name: string) -> (pod: string)

# RestartPod will restart containers in a pod given a pod name or ID. Containers in
# the pod that are running will be stopped, then all stopped containers will be run.
# If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
# Containers in a pod are restarted independently. If there is an error restarting one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was restarted with no errors, the pod ID is returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.RestartPod '{"name": "135d71b9495f"}'
# {
#   "pod": "135d71b9495f7c3967f536edad57750bfdb569336cd107d8aabab45565ffcfb6"
# }
# ~~~
method RestartPod(name: string) -> (pod: string)

# KillPod takes the name or ID of a pod as well as a signal to be applied to the pod.  If the pod cannot be found, a
# [PodNotFound](#PodNotFound) error is returned.
# Containers in a pod are killed independently. If there is an error killing one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was killed with no errors, the pod ID is returned.
# See also [StopPod](StopPod).
method KillPod(name: string, signal: int) -> (pod: string)

# PausePod takes the name or ID of a pod and pauses the running containers associated with it.  If the pod cannot be found,
# a [PodNotFound](#PodNotFound) error will be returned.
# Containers in a pod are paused independently. If there is an error pausing one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was paused with no errors, the pod ID is returned.
# See also [UnpausePod](#UnpausePod).
method PausePod(name: string) -> (pod: string)

# UnpausePod takes the name or ID of a pod and unpauses the paused containers associated with it.  If the pod cannot be
# found, a [PodNotFound](#PodNotFound) error will be returned.
# Containers in a pod are unpaused independently. If there is an error unpausing one container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was unpaused with no errors, the pod ID is returned.
# See also [PausePod](#PausePod).
method UnpausePod(name: string) -> (pod: string)

# RemovePod takes the name or ID of a pod as well a boolean representing whether a running
# container in the pod can be stopped and removed.  If a pod has containers associated with it, and force is not true,
# an error will occur.
# If the pod cannot be found by name or ID, a [PodNotFound](#PodNotFound) error will be returned.
# Containers in a pod are removed independently. If there is an error removing any container, the ID of those containers
# will be returned in a list, along with the ID of the pod in a [PodContainerError](#PodContainerError).
# If the pod was removed with no errors, the pod ID is returned.
# #### Example
# ~~~
# $ varlink call -m unix:/run/podman/io.podman/io.podman.RemovePod '{"name": "62f4fd98cb57", "force": "true"}'
# {
#   "pod": "62f4fd98cb57f529831e8f90610e54bba74bd6f02920ffb485e15376ed365c20"
# }
# ~~~
method RemovePod(name: string, force: bool) -> (pod: string)

# This method has not be implemented yet.
method WaitPod() -> (notimplemented: NotImplemented)

# This method has not been implemented yet.
method TopPod() -> (notimplemented: NotImplemented)

# GetPodStats takes the name or ID of a pod and returns a pod name and slice of ContainerStats structure which
# contains attributes like memory and cpu usage.  If the pod cannot be found, a [PodNotFound](#PodNotFound)
# error will be returned.  If the pod has no running containers associated with it, a [NoContainerRunning](#NoContainerRunning)
# error will be returned.
# #### Example
# ~~~
# $ varlink call unix:/run/podman/io.podman/io.podman.GetPodStats '{"name": "7f62b508b6f12b11d8fe02e"}'
# {
#   "containers": [
#     {
#       "block_input": 0,
#       "block_output": 0,
#       "cpu": 2.833470544016107524276e-08,
#       "cpu_nano": 54363072,
#       "id": "a64b51f805121fe2c5a3dc5112eb61d6ed139e3d1c99110360d08b58d48e4a93",
#       "mem_limit": 12276146176,
#       "mem_perc": 7.974359265237864966003e-03,
#       "mem_usage": 978944,
#       "name": "quirky_heisenberg",
#       "net_input": 866,
#       "net_output": 7388,
#       "pids": 1,
#       "system_nano": 20000000
#     }
#   ],
#   "pod": "7f62b508b6f12b11d8fe02e0db4de6b9e43a7d7699b33a4fc0d574f6e82b4ebd"
# }
# ~~~
method GetPodStats(name: string) -> (pod: string, containers: []ContainerStats)

# ImageNotFound means the image could not be found by the provided name or ID in local storage.
error ImageNotFound (name: string)

# ContainerNotFound means the container could not be found by the provided name or ID in local storage.
error ContainerNotFound (name: string)

# NoContainerRunning means none of the containers requested are running in a command that requires a running container.
error NoContainerRunning ()

# PodNotFound means the pod could not be found by the provided name or ID in local storage.
error PodNotFound (name: string)

# PodContainerError means a container associated with a pod failed to preform an operation. It contains
# a container ID of the container that failed.
error PodContainerError (podname: string, errors: []PodContainerErrorData)

# NoContainersInPod means a pod has no containers on which to perform the operation. It contains
# the pod ID.
error NoContainersInPod (name: string)

# ErrorOccurred is a generic error for an error that occurs during the execution.  The actual error message
# is includes as part of the error's text.
error ErrorOccurred (reason: string)

# RuntimeErrors generally means a runtime could not be found or gotten.
error RuntimeError (reason: string)
`
}

// Generated service interface

type VarlinkInterface struct {
	iopodmanInterface
}

func VarlinkNew(m iopodmanInterface) *VarlinkInterface {
	return &VarlinkInterface{m}
}
